/*
 *     nanoMir
 *
 *     "cmn.h"          Editor commands - enumeration
 */

/* Don't change enumeration of LE_CHAR ... TE_SPREM commands */
#define CM_MIN      0400
#define LE_CHAR     0400
#define LE_RIGHT    0401
#define LE_LEFT     0402
#define LE_DEOL     0403
#define LE_DBGOL    0404
#define LE_BEG      0405
#define LE_END      0406
#define LE_IC       0407
#define LE_DC       0410
#define LE_BS       0411
#define LE_TAB      0412
#define LE_LTAB     0413
#define LE_NWORD    0414
#define LE_PWORD    0415
#define LE_CCHAR    0416
#define LE_CDCHAR   0417
#define LE_PCHAR    0420
#define LE_CCCHR    0421
#define LE_CWORD    0422
#define LE_CDWORD   0423
#define LE_DWORD    0424
#define LE_DLWORD   0425
#define LE_CENTR    0426

#define LE_RINS     0427
#define LE_RREP     0430
#define LE_CCUP     0431
#define LE_CCDWN    0432
#define LE_CCRUS    0433
#define LE_CCLAT    0434
#define LE_CATTR    0435
#define LE_SPCHAR   0436
#define LE_ESCCHR   0437
#define LE_HFCHAR   0440

#define LA_NONE     0441
#define LA_LIGHT    0442
#define LA_ITALIC   0443
#define LA_UNDERL   0444
#define LA_BOLD     0445
#define LA_SUPER    0446
#define LA_SUBSCR   0447
#define LA_INVERT   0450

#define TE_UNDO     0451
#define TE_UNUNDO   0452
#define TE_SUNDO    0453
#define TE_SUNUNDO  0454

#define TE_SRO      0455
#define TE_SRW      0456
#define TE_SWIGHT   0457

#define TE_SMARK    0460
#define TE_CMARK    0461

#define TE_PTAB     0462
#define TE_PFORM    0463

#define TE_UP       0464
#define TE_DOWN     0465
#define TE_CUP      0466
#define TE_CDOWN    0467
#define TE_TBEG     0470
#define TE_TEND     0471

#define TE_IL       0472
#define TE_DL       0473
#define TE_CR       0474
#define TE_RCR      0475
#define TE_SENTR    0476
#define TE_SUP      0477
#define TE_SDOWN    0500
#define TE_CENTR    0501
#define TE_CLIN     0502
#define TE_CDLIN    0503
#define TE_PLIN     0504
#define TE_CCLIN    0505
#define TE_BLIN     0506
#define TE_SLIN     0507
#define TE_NBLIN    0510
#define TE_NSLIN    0511
#define TE_IPAGE    0512
#define TE_NPAGE    0513
#define TE_PPAGE    0514

#define TE_MCBLOCK  0515
#define TE_CDBLOCK  0516
#define TE_CCBLOCK  0517
#define TE_PBLOCK   0520
#define TE_PRBLOCK  0521
#define TE_PIBLOCK  0522
#define TE_PIRBLOCK 0523

#define TE_LPRINT   0524
#define TE_FPRINT   0525
#define TE_FORMAT   0526
#define TE_PFORMAT  0527
#define TE_LDUP     0530
#define TE_LDDOWN   0531
#define TE_LDLEFT   0532
#define TE_LDRIGHT  0533
#define TE_RUP      0534
#define TE_RDOWN    0535
#ifdef X11
#define TE_SETXY    0536
#endif
#define TE_PPRINT   0536
#define TE_IPRINT   0537
#define TE_RSPELL   0541
#define TE_LSPELL   0542
#define TE_SPADD    0543
#define TE_SPREM    0544

#define TE_HELP     0644
#ifdef  VERSION_2
#define TE_MSGS     0643
#else
#define TE_MSGS     0013
#endif /* VERSION_2 */
#define TE_FENTR    0545
#define TE_F2ENTR   0546
#define TE_EXEC     0645
#define TE_FEXEC    0547
#define TE_SHELL    0550
#define TE_INFILE   0551
#define TE_OUTFILE  0552

#define TE_MODFILE  02020
#define TE_BLKEXEC  02021

#define TE_UPDATE   0553
#define TE_EXIT     0554
#define TE_EXOLD    0555
#define TE_EXBACK   0556
#define TE_QUIT     0557
#define TE_CRASH    0646
#define TE_NERROR   0560
#define TE_PERROR   0561
#define TE_ERROFF   02022
#ifndef X11
#define TE_UFORK    0562
#define TE_DFORK    02003
#define TE_RFORK    02004
#define TE_LFORK    0563
#else
#define TE_FORK     0562
#endif

#ifndef X11
#define TE_UWINDOW  0564
#define TE_DWINDOW  0565
#define TE_RWINDOW  0566
#define TE_LWINDOW  0567
#else
#define TE_FOCUS    0564
#define TE_NWINDOW  0565
#define TE_PWINDOW  0566
#endif

#define TE_STATUS   02023
#define TE_ZOOM     02024
#define TE_OHELP    02025
#define TE_BLKMOD   0540

#define TK_BREAK    0570
#define TK_CTRLO    0571
#define TK_ESC      0572
#define TK_REPEAT   0573
#define TK_BRUS     0574
#define TK_SRUS     0575
#define TK_BLAT     0576
#define TK_SLAT     0577
#define TK_SM       0600
#define TK_EM       0700

#define TD_SDEQ     02001
#define TD_STXT     02002

#define TK_DATE     02005
#define TK_TIME     02006

#define MC_SAVE     02007
#define MC_LOAD     02010
#define MC_2SAVE    02011
#define MC_2LOAD    02012

#define TK_CSET     02014
#define TK_CADD     02015
#define TK_CSUB     02016
#define TK_CPUT     02017


/* Following commands are used in F-praktikum */

#define MC_INCL     03001
#define MC_PROC     03000
#define MC_SUBR     03003
#define MC_FUNC     03002
#define MC_IF       03004
#define MC_WHIL     03005
#define MC_DSEC     TE_NSLIN
#define MC_DO       03007

#define DB_DUMP     03020
#define DB_TRACE    03021

#define EX_EXEC     03030
#define EX_CEXEC    03031
#define EX_FEXEC    03032
