#include "cmn.h"
#include "kbxdpc.h"

#define MAXTABS 50
#define MAXLENTAB 200
#define FILE_NAME "xdpc.cm"

short origin_table[] = {

LE_RIGHT   ,RIGHT,             -1,/*  0401  + */
LE_LEFT    ,LEFT,              -1,/*  0402  + */
LE_DEOL    ,CTRL_D,            -1,/*  0403  + */
LE_DBGOL   ,CTRL_U,            -1,/*  0404  + */
LE_BEG     ,N5,LEFT,           -1,/*  0405  + */
LE_BEG     ,CTRL_LEFT,         -1,/*  0405  + */
LE_END     ,N5,RIGHT,          -1,/*  0406  + */
LE_END     ,CTRL_RIGHT,        -1,/*  0406  + */
LE_IC      ,Insert,            -1,/*  0407  + */
LE_IC      ,N9,                -1,/*  0407  + */
LE_DC      ,Remove,            -1,/*  0410  + */
LE_DC      ,N8,                -1,/*  0410  + */
LE_BS      ,ZB,                -1,/*  0411  + */
LE_TAB     ,Tab,               -1,/*  0412  + */
LE_TAB     ,LE_TAB,            -1,/*  0412  + */
LE_LTAB    ,SHIFT_Tab,         -1,/*  0413  + */
LE_NWORD   ,SHIFT_RIGHT,       -1,/*  0414  + */
LE_PWORD   ,SHIFT_LEFT,        -1,/*  0415  + */
LE_CCHAR   ,F2,                -1,/*  0416  + */
LE_CCHAR   ,N0,                -1,/*  0416  + */
LE_CDCHAR  ,SHIFT_F2,          -1,/*  0417  + */
LE_PCHAR   ,F3,                -1,/*  0420  + */
LE_PCHAR   ,DOT,               -1,/*  0420  + */
LE_CCCHR   ,SHIFT_F3,          -1,/*  0421  + */
LE_CWORD   ,ALT_F2,            -1,/*  0422  + */
LE_CDWORD  ,SHIFT_ALT_F2,      -1,/*  0423  + */
LE_DWORD   ,CTRL_ZB,           -1,/*  0424  + */
LE_DLWORD  ,                   -1,/*  0425  + */
LE_CENTR   ,CTRL_T,            -1,/*  0426  + */

LE_RINS    ,CTRL_Insert,       -1,/*  0427  +  */
LE_RREP    ,CTRL_Remove,       -1,/*  0430  +  */
LE_CCUP    ,ALT_UP,            -1,/*  0431  +  */
LE_CCDWN   ,ALT_DOWN,          -1,/*  0432  +  */
LE_CCRUS   ,ALT_RIGHT,         -1,/*  0433  +  */
LE_CCLAT   ,ALT_LEFT,          -1,/*  0434  +  */
LE_CATTR   ,                   -1,/*  0435 ??? CTRL_SHIFT_SPACE no recognised */
LE_SPCHAR  ,                   -1,/*  0436     */
LE_ESCCHR  ,                   -1,/*  0437  ESC (033 ) */
LE_HFCHAR  ,MINUS,             -1,/*  0440 (0???) + */

LA_NONE    ,CTRL_SPACE,        -1,/*  0441    + */
LA_LIGHT   ,                   -1,/*  0442    + */
LA_ITALIC  ,                   -1,/*  0443    + */
LA_UNDERL  ,                   -1,/*  0444    + */
LA_BOLD    ,                   -1,/*  0445    + */
LA_SUPER   ,                   -1,/*  0446    + */
LA_SUBSCR  ,                   -1,/*  0447    + */
LA_INVERT  ,                   -1,/*  0450    + */

TE_UNDO    ,Do,                -1,/*  0451 + */
TE_UNUNDO  ,CTRL_Do,           -1,/*  0452 + */
TE_UNUNDO  ,SHIFT_Do,          -1,/*  0452 + */
TE_UNUNDO  ,CTRL_SHIFT_Do,     -1,/*  0452 + */
TE_SUNDO   ,                   -1,/*  0453   */
TE_SUNUNDO ,                   -1,/*  0454   */

TE_SRO     ,N5, CTRL_T,        -1,/*  0455   */
TE_SRW     ,N5, CTRL_E,        -1,/*  0456   */
TE_SWIGHT  ,                   -1,/*  0457   */

TE_SMARK   ,CTRL_Tab,          -1,/*  0460 + */
TE_CMARK   ,CTRL_SHIFT_Tab,    -1,/*  0461 + */

TE_PTAB    ,N5,Tab,            -1,/*  0462 + */
TE_PFORM   ,N5,F9,             -1,/*  0463 + */

TE_UP      ,UP,                -1,/*  0464 +  */
TE_DOWN    ,DOWN,              -1,/*  0465 +  */
TE_CUP     ,CTRL_UP,           -1,/*  0466 +  */
TE_CUP     ,N5,UP,             -1,/*  0466 +  */
TE_CDOWN   ,CTRL_DOWN,         -1,/*  0467 +  */
TE_CDOWN   ,N5,DOWN,           -1,/*  0467 +  */
TE_TBEG    ,CTRL_SHIFT_UP,     -1,/*  0470 +  */
TE_TEND    ,CTRL_SHIFT_DOWN,   -1,/*  0471 +  */

TE_IL      ,SHIFT_Insert,      -1,/*  0472 +  */
TE_DL      ,SHIFT_Remove,      -1,/*  0473 +  */
TE_CR      ,Return,            -1,/*  0474 +  */
TE_CR      ,TE_CR,             -1,/*  0474 +  */
TE_RCR     ,                   -1,/*  0475 +  */
TE_SENTR   ,N5, PF4,           -1,/*  0476 +  */
TE_SENTR   ,PF2, N7,           -1,/*  0476 +  */
TE_SUP     ,SHIFT_PF4,         -1,/*  0477 +  */
TE_SDOWN   ,PF4,               -1,/*  0500 +  */
TE_SDOWN   ,N7,                -1,/*  0500 +  */
TE_CENTR   ,CTRL_E,            -1,/*  0501 +  */
TE_CLIN    ,F4,                -1,/*  0502 +  */
TE_CLIN    ,N2,                -1,/*  0502 +  */
TE_CDLIN   ,SHIFT_F4,          -1,/*  0503 +  */
TE_PLIN    ,F5,                -1,/*  0504 +  */
TE_PLIN    ,N3,                -1,/*  0504 +  */
TE_CCLIN   ,SHIFT_F5,          -1,/*  0505 +  */
TE_BLIN    ,N5,Return,         -1,/*  0506 +  */
TE_SLIN    ,N5,Insert,         -1,/*  0507 +  */
TE_NBLIN   ,N5,ZB,             -1,/*  0510 +  */
TE_NSLIN   ,N5,Remove,         -1,/*  0511 +  */
TE_IPAGE   ,                   -1,/*  0512     */
TE_NPAGE   ,NextScreen,        -1,/*  0513 +  */
TE_PPAGE   ,PrevScreen,        -1,/*  0514 +  */

TE_MCBLOCK ,F6,                -1,/*  0515 +    */
TE_CDBLOCK ,CTRL_F6,           -1,/*  0516 +    */
TE_CCBLOCK ,SHIFT_F6,          -1,/*  0517 +    */
TE_PBLOCK  ,F7,                -1,/*  0520 +  */
TE_PRBLOCK ,SHIFT_F7,          -1,/*  0521 +     */
TE_PIBLOCK ,CTRL_F7,           -1,/*  0522 +  */
TE_PIRBLOCK,CTRL_SHIFT_F7,     -1,/*  0523 +     */
TE_BLKEXEC ,                   -1,/*  1021 + */
TE_BLKMOD  ,                   -1,/*  ???? */

TE_LPRINT  ,                   -1,/*  0524    */
TE_FPRINT  ,                   -1,/*  0525    */
TE_FORMAT  ,F9,                -1,/*  0526 +  */
TE_PFORMAT ,SHIFT_F9,          -1,/*  0527 +  */
TE_LDUP    ,COMPOSE_UP,        -1,/*  0530 +   */
TE_LDDOWN  ,COMPOSE_DOWN,      -1,/*  0531 +   */
TE_LDLEFT  ,COMPOSE_LEFT,      -1,/*  0532 +   */
TE_LDRIGHT ,COMPOSE_RIGHT,     -1,/*  0533 +   */
TE_RUP     ,SHIFT_ALT_PF4,     -1,/*  0534 +    */
TE_RDOWN   ,ALT_PF4,           -1,/*  0535 +    */
TE_RDOWN   ,PF1, N7,           -1,/*  0535 +    */

TE_PPRINT  ,                   -1,/*  0536  c   */
TE_IPRINT  ,                   -1,/*  0537  (  */
TE_RSPELL  ,                   -1,/*  0540  /  */
TE_LSPELL  ,                   -1,/*  0541 */
TE_SPADD   ,                   -1,/*  0542  $    */
TE_SPREM   ,                   -1,/*  0543     */

TE_HELP    ,Help,              -1,/*  0544  help + */
TE_OHELP   ,CTRL_H,            -1,/*  0544  help + */
TE_MSGS    ,                   -1,/* 01013  +   */
TE_FENTR   ,F1  ,DOWN,         -1,/*  0545  +   */
TE_FENTR   ,PF3 ,DOWN,         -1,/*  0545  +   */
TE_F2ENTR  ,F1  ,F1  ,         -1,/*  0546  +   */
TE_F2ENTR  ,PF3 ,PF3 ,         -1,/*  0546  +   */
TE_FEXEC   ,                   -1,/*  0547  +   */
TE_EXEC    ,                   -1,/*  0547  +   */
TE_SHELL   ,Enter,             -1,/*  0550  +   cli */
TE_INFILE  ,F1 ,RIGHT,         -1,/*  0551  + enter filename */
TE_INFILE  ,PF3,RIGHT,         -1,/*  0551  + enter filename */
TE_OUTFILE ,F1 ,LEFT,          -1,/*  0552  + leave filename */
TE_OUTFILE ,PF3,LEFT,          -1,/*  0552  + leave filename */

TE_MODFILE ,F1 ,CTRL_U,        -1,/*        + */
TE_MODFILE ,PF3,CTRL_U,        -1,/*        + */

TE_UPDATE  ,N5,F1 ,            -1,/*  0553  + */
TE_UPDATE  ,N5,PF3,            -1,/*  0553  + */
TE_EXIT    ,F1 ,UP,            -1,/*  0554  + */
TE_EXIT    ,PF3,UP,            -1,/*  0554  + */
TE_EXOLD   ,F1 ,CTRL_C,        -1,/*  0555  + */
TE_EXOLD   ,PF3,CTRL_C,        -1,/*  0555  + */
TE_EXBACK  ,F1 ,ZB,            -1,/*  0556  + */
TE_EXBACK  ,PF3,ZB,            -1,/*  0556  + */
TE_QUIT    ,PF1,PF1,           -1,/*  0557      */
TE_CRASH   ,F1 ,CTRL_T,        -1,/*  0557  + */
TE_CRASH   ,PF3,CTRL_T,        -1,/*  0557  + */
TE_NERROR  ,F10,UP,            -1,/*  0560  + */
TE_PERROR  ,F10,DOWN,          -1,/*  0561  + */
TE_ERROFF  ,F10, F10,          -1,/* 01022  + */
TE_STATUS  ,CTRL_S,            -1,/* 01023  + */
TE_FORK    ,F1 ,PF4,           -1,/*  0562 + fork     */
TE_FORK    ,PF3,PF4,           -1,/*  0562 + fork     */
TE_FORK    ,F11,               -1,/*  0562 + fork     */
TE_FOCUS   ,TE_FOCUS,          -1,/*  0562 + fork     */
TE_SETXY   ,TE_SETXY,          -1,/*  0562 + fork     */

TK_BREAK   ,CTRL_C,            -1,/*  0570    +  */
TK_CTRLO   ,                   -1,/*  0571  / +  */
TK_REPEAT  ,N5,N5,             -1,/*  0573  / + */
TK_BRUS    ,                   -1,/*  0574  /   */
TK_SRUS    ,CTRL_F14,          -1,/*  0575  a +  */
TK_BLAT    ,                   -1,/*  0576  /   */
TK_SLAT    ,F14,               -1,/*  0577  a +  */
TK_SM+0    ,SHIFT_F8,          -1,/*  0600  +  0 */
TK_SM+0    ,PF2,N4,            -1,/*  0600  +  0 */
TK_EM+0    ,F8,                -1,/*  0700  +/  0 */
TK_EM+0    ,N4,                -1,/*  0700  +/  0 */
TK_SM+1    ,CTRL_SHIFT_3,      -1,/*  0600  +  0 */
TK_EM+1    ,CTRL_3,            -1,/*  0700  +/  0 */
TK_SM+2    ,CTRL_SHIFT_4,      -1,/*  0600     0 */
TK_EM+2    ,CTRL_4,            -1,/*  0700   /  0 */
TK_SM+3    ,CTRL_SHIFT_5,      -1,/*  0600     0 */
TK_EM+3    ,CTRL_5,            -1,/*  0700   /  0 */
TK_SM+4    ,CTRL_SHIFT_6,      -1,/*  0600     0 */
TK_EM+4    ,CTRL_6,            -1,/*  0700   /  0 */
TK_SM+5    ,CTRL_SHIFT_7,      -1,/*  0600     0 */
TK_EM+5    ,CTRL_7,            -1,/*  0700   /  0 */
TK_SM+6    ,CTRL_SHIFT_8,      -1,/*  0600     0 */
TK_EM+6    ,CTRL_8,            -1,/*  0700   /  0 */
TK_SM+7    ,CTRL_SHIFT_9,      -1,/*  0600     0 */
TK_EM+7    ,CTRL_9,            -1,/*  0700   /  0 */
TK_SM+8    ,CTRL_SHIFT_0,      -1,/*  0600     0 */
TK_EM+8    ,CTRL_0,            -1,/*  0700   /  0 */
TK_SM+9    ,                   -1,/*  0600     0 */
TK_EM+9    ,                   -1,/*  0700   /  0 */
TK_SM+10   ,                   -1,/*  0600     0 */
TK_EM+10   ,                   -1,/*  0700   /  0 */
TK_SM+11   ,                   -1,/*  0600     0 */
TK_EM+11   ,                   -1,/*  0700   /  0 */




TD_SDEQ    ,                   -1,/*  01001* /  */
TD_STXT    ,                   -1,/*  01002* /  */
TK_CSET    ,PF1,N2,            -1,
TK_CADD    ,PF1,N9,            -1,
TK_CSUB    ,PF1,N8,            -1,
TK_CPUT    ,PF1,N3,            -1,
TK_DATE    ,PF1,CTRL_D,        -1,/*  01005  "   */
TK_TIME    ,PF1,CTRL_T,        -1,/*  01006  "   */
MC_SAVE    ,COMMA,COMMA,N0,    -1,/*  01007  "    */
MC_LOAD    ,COMMA,COMMA,DOT,   -1,/*  01010  '    */
MC_2SAVE   ,COMMA,N0,          -1,/*  01011  "    */
MC_2LOAD   ,COMMA,DOT,         -1,/*  01012  '    */

EX_EXEC    ,N1,                -1,/*  02030  '    */
EX_CEXEC   ,PF2,N1,            -1,/*  02031  '    */
EX_FEXEC   ,PF3,N1,            -1,/*  02032  '    */

MC_INCL    ,PF3,'j',           -1,/*  02000  '    */
MC_INCL    ,PF3,'J',           -1,/*  02000  '    */
MC_PROC    ,PF3,'p',           -1,/*  02000  '    */
MC_PROC    ,PF3,'P',           -1,/*  02000  '    */
MC_SUBR    ,PF3,'s',           -1,/*  02000  '    */
MC_SUBR    ,PF3,'S',           -1,/*  02000  '    */
MC_FUNC    ,PF3,'f',           -1,/*  02000  '    */
MC_FUNC    ,PF3,'F',           -1,/*  02000  '    */
MC_WHIL    ,PF3,'w',           -1,/*  02000  '    */
MC_WHIL    ,PF3,'W',           -1,/*  02000  '    */
MC_DO      ,PF3,'d',           -1,/*  02000  '    */
MC_DO      ,PF3,'D',           -1,/*  02000  '    */
MC_IF      ,PF3,'i',           -1,/*  02000  '    */
MC_IF      ,PF3,'I',           -1,/*  02000  '    */

DB_DUMP    ,PF3,'V',           -1,/*  02000  '    */
DB_DUMP    ,PF3,'v',           -1,/*  02000  '    */
DB_TRACE   ,PF3,'T',           -1,/*  02000  '    */
DB_TRACE   ,PF3,'t',           -1,/*  02000  '    */

-1};

short special_table[] = {

TK_ESC     ,F1 ,               /*  0572  Esc */
TK_ESC     ,PF3,               /*  0572  Esc */
-1};

#include "gentab.c"
