#include "kbxtermlinux.h"

#define MAXTABS 200
#define MAXLENTAB 800
/*
#define MAXTABS 50
#define MAXLENTAB 200
*/
#define FILE_NAME "xtermlinux.kb"

short origin_table[] = {

CTRL_A          , 0001,                  -1,
CTRL_B          , 0002,                  -1,
CTRL_C          , 0003,                  -1,
CTRL_D          , 0004,                  -1,
CTRL_E          , 0005,                  -1,
CTRL_F          , 0006,                  -1,
CTRL_G          , 0007,                  -1,
CTRL_H          , 0010,                  -1,
TAB             , 0011,                  -1,
CTRL_J          , 0012,                  -1,
CTRL_K          , 0013,                  -1,
CTRL_L          , 0014,                  -1,
RETURN          , 0015,                  -1,
CTRL_N          , 0016,                  -1,
CTRL_O          , 0017,                  -1,
CTRL_P          , 0020,                  -1,
CTRL_Q          , 0021,                  -1,
CTRL_R          , 0022,                  -1,
CTRL_S          , 0023,                  -1,
CTRL_T          , 0024,                  -1,
CTRL_U          , 0025,                  -1,
CTRL_V          , 0026,                  -1,
CTRL_W          , 0027,                  -1,
CTRL_X          , 0030,                  -1,
CTRL_Y          , 0031,                  -1,
CTRL_Z          , 0032,                  -1,
//BACKSPACE       , 0177,                  -1,

UP              , 033,'[','A',           -1,
DOWN            , 033,'[','B',           -1,
RIGHT           , 033,'[','C',           -1,
LEFT            , 033,'[','D',           -1,
F1              , 033,'[','1', '1',0176, -1,
F2              , 033,'[','1', '2',0176, -1,
F3              , 033,'[','1', '3',0176, -1,
F4              , 033,'[','1', '4',0176, -1,
F5              , 033,'[','1', '5',0176, -1,
F6              , 033,'[','1','7',0176,  -1,
F7              , 033,'[','1','8',0176,  -1,
F8              , 033,'[','1','9',0176,  -1,
F9              , 033,'[','2','0',0176,  -1,
F10             , 033,'[','2','1',0176,  -1,

SHIFT_F1        , 033,'[','2','3','~',   -1,
SHIFT_F2        , 033,'[','2','4','~',   -1,
SHIFT_F3        , 033,'[','2','5','~',   -1,
SHIFT_F4        , 033,'[','2','6','~',   -1,
SHIFT_F5        , 033,'[','2','8','~',   -1,
SHIFT_F6        , 033,'[','2','9','~',   -1,
SHIFT_F7        , 033,'[','3','1','~',   -1,
SHIFT_F8        , 033,'[','3','2','~',   -1,
SHIFT_F9        , 033,'[','3','3','~',   -1,
SHIFT_F10       , 033,'[','3','4','~',   -1,

//CTRL_F1         , 033,'[','4','0','~',   -1,
//CTRL_F2         , 033,'[','4','1','~',   -1,
//CTRL_F3         , 033,'[','4','2','~',   -1,
//CTRL_F4         , 033,'[','4','3','~',   -1,
//CTRL_F5         , 033,'[','4','4','~',   -1,
//CTRL_F6         , 033,'[','4','5','~',   -1,
//CTRL_F7         , 033,'[','4','6','~',   -1,
//CTRL_F8         , 033,'[','4','7','~',   -1,
//CTRL_F9         , 033,'[','4','8','~',   -1,
//CTRL_F10        , 033,'[','4','9','~',   -1,

//CTRL_SHIFT_F1   , 033,'[','5','0','~',   -1,
//CTRL_SHIFT_F2   , 033,'[','5','1','~',   -1,
//CTRL_SHIFT_F3   , 033,'[','5','2','~',   -1,
//CTRL_SHIFT_F4   , 033,'[','5','3','~',   -1,
//CTRL_SHIFT_F5   , 033,'[','5','4','~',   -1,
//CTRL_SHIFT_F6   , 033,'[','5','5','~',   -1,
//CTRL_SHIFT_F7   , 033,'[','5','6','~',   -1,
//CTRL_SHIFT_F8   , 033,'[','5','7','~',   -1,
//CTRL_SHIFT_F9   , 033,'[','5','8','~',   -1,
//CTRL_SHIFT_F10  , 033,'[','5','9','~',   -1,

//F11             , 033,'[','6','0','~',   -1,
//F12             , 033,'[','6','1','~',   -1,
//SHIFT_F11       , 033,'[','6','2','~',   -1,
//SHIFT_F12       , 033,'[','6','3','~',   -1,
//CTRL_F11        , 033,'[','6','4','~',   -1,
//CTRL_F12        , 033,'[','6','5','~',   -1,
//CTRL_SHIFT_F11  , 033,'[','6','6','~',   -1,
//CTRL_SHIFT_F12  , 033,'[','6','7','~',   -1,
//SHIFT_PLUS      , 033,'[','6','8','~',   -1,
//ALT_ESC         , 033,'[','6','9','~',   -1,

//SHIFT_LEFT      , 033,'[','7','0','~',   -1,
//CTRL_LEFT       , 033,'[','7','1','~',   -1,
//ALTGR_LEFT      , 033,'[','7','2','~',   -1,
//ALT_CTRL_LEFT   , 033,'[','7','3','~',   -1,

//SHIFT_RIGHT     , 033,'[','7','4','~',   -1,
//CTRL_RIGHT      , 033,'[','7','5','~',   -1,
//ALTGR_RIGHT     , 033,'[','7','6','~',   -1,
//ALT_CTRL_RIGHT  , 033,'[','7','7','~',   -1,

//ALT_UP          , 033,'[','7','8','~',   -1,
//SHIFT_UP        , 033,'[','7','9','~',   -1,
//CTRL_UP         , 033,'[','8','0','~',   -1,
//ALTGR_UP        , 033,'[','8','1','~',   -1,
//ALT_CTRL_UP     , 033,'[','8','2','~',   -1,
//CTRL_SHIFT_UP   , 033,'[','8','3','~',   -1,

//ALT_DOWN        , 033,'[','8','4','~',   -1,
//SHIFT_DOWN      , 033,'[','8','5','~',   -1,
//CTRL_DOWN       , 033,'[','8','6','~',   -1,
//ALTGR_DOWN      , 033,'[','8','7','~',   -1,
//ALT_CTRL_DOWN   , 033,'[','8','8','~',   -1,
//CTRL_SHIFT_DOWN , 033,'[','8','9','~',   -1,

//SHIFT_INSERT    , 033,'[','9','0','~',   -1,
//CTRL_INSERT     , 033,'[','9','1','~',   -1,
//SHIFT_DELETE    , 033,'[','9','2','~',   -1,
//CTRL_DELETE     , 033,'[','9','3','~',   -1,
//SHIFT_TAB       , 033,'[','9','4','~',   -1,
//CTRL_TAB        , 033,'[','9','5','~',   -1,
//CTRL_SHIFT_TAB  , 033,'[','9','6','~',   -1,
//SHIFT_BACKSPACE , 033,'[','9','7','~',   -1,
//ALT_CTRL_BACKSPACE, 033,'[','9','8','~',   -1,
//CTRL_SHIFT_SPACE, 033,'[','9','9','~',   -1,

//CTRL_ENTER      , 033,'[','a','0','~',   -1,
//CTRL_RETURN     , 033,'[','a','1','~',   -1,
//ALT_CTRL_RETURN , 033,'[','a','2','~',   -1,
//CTRL_PageUp     , 033,'[','a','3','~',   -1,
//CTRL_PageDown   , 033,'[','a','4','~',   -1,
//SHIFT_STAR      , 033,'[','a','5','~',   -1,
//ALT_STAR        , 033,'[','a','6','~',   -1,
//ALT_CTRL_STAR   , 033,'[','a','7','~',   -1,
//ALT_MINUS       , 033,'[','a','8','~',   -1,
//SHIFT_MINUS     , 033,'[','a','9','~',   -1,

//CTRL_1          , 033,'[','b','0','~',   -1,
//CTRL_2          , 033,'[','b','1','~',   -1,
//CTRL_3          , 033,'[','b','2','~',   -1,
//CTRL_4          , 033,'[','b','3','~',   -1,
//CTRL_5          , 033,'[','b','4','~',   -1,
//CTRL_6          , 033,'[','b','5','~',   -1,
//CTRL_7          , 033,'[','b','6','~',   -1,
//CTRL_8          , 033,'[','b','7','~',   -1,
//CTRL_9          , 033,'[','b','8','~',   -1,
//CTRL_0          , 033,'[','b','9','~',   -1,

//CTRL_QUESTION   , 033,'[','c','2','~',   -1,
CTRL_QUESTION     , 037,                   -1,
//CTRL_SPACE      , 033,'[','c','1','~',   -1,
CTRL_SPACE        , 0,                     -1,
//ALTGR_RETURN    , 033,'[','c','3','~',   -1,
//CTRL_BACKSPACE  , 033,'[','c','0','~',   -1,

//CTRL_SHIFT_1    , 033,'[','d','0','~',   -1,
//CTRL_SHIFT_2    , 033,'[','d','1','~',   -1,
//CTRL_SHIFT_3    , 033,'[','d','2','~',   -1,
//CTRL_SHIFT_4    , 033,'[','d','3','~',   -1,
//CTRL_SHIFT_5    , 033,'[','d','4','~',   -1,
//CTRL_SHIFT_6    , 033,'[','d','5','~',   -1,
//CTRL_SHIFT_7    , 033,'[','d','6','~',   -1,
//CTRL_SHIFT_8    , 033,'[','d','7','~',   -1,
//CTRL_SHIFT_9    , 033,'[','d','8','~',   -1,
//CTRL_SHIFT_0    , 033,'[','d','9','~',   -1,

HOME            , 033,'[',0,             -1,
INSERT          , 033,'[','2',0176,      -1,
//DELETE          , 033,'[','3',0176,      -1,
DELETE          , 0177,                  -1,
END             , 033,'[','e',           -1,
//PageUp          , 033,'[','5',0176,      -1,
//PageDown        , 033,'[','6',0176,      -1,
//NumLock         , 033,'O','P',           -1,
SLASH           , 033,'O','o',           -1,
STAR            , 033,'O','j',           -1,
MINUS           , 033,'O','m',           -1,
ENTER           , 033,'O','M',           -1,
DOT             , 033,'O','n',           -1,
N0              , 033,'O','p',           -1,
N1              , 033,'O','q',           -1,
N2              , 033,'O','r',           -1,
N3              , 033,'O','s',           -1,
N4              , 033,'O','t',           -1,
N5              , 033,'O','u',           -1,
N6              , 033,'O','v',           -1,
N7              , 033,'O','w',           -1,
N8              , 033,'O','x',           -1,
N9              , 033,'O','y',           -1,
PLUS            , 033, 'O', 'k',         -1,
//Pause           , 033, '[', 'P',         -1,
//
// Alt    !
//
#if 0
ALT_A           ,       0xffe1,         -1,
ALT_B           ,       0xffe2,         -1,
ALT_C           ,       0xffe3,         -1,
ALT_D           ,       0xffe4,         -1,
ALT_E           ,       0xffe5,         -1,
ALT_F           ,       0xffe6,         -1,
ALT_G           ,       0xffe7,         -1,
ALT_H           ,       0xffe8,         -1,
ALT_I           ,       0xffe9,         -1,
ALT_J           ,       0xffea,         -1,
ALT_K           ,       0xffeb,         -1,
ALT_L           ,       0xffec,         -1,
ALT_M           ,       0xffed,         -1,
ALT_N           ,       0xffee,         -1,
ALT_O           ,       0xffef,         -1,
ALT_P           ,       0xfff0,         -1,
ALT_Q           ,       0xfff1,         -1,
ALT_R           ,       0xfff2,         -1,
ALT_S           ,       0xfff3,         -1,
ALT_T           ,       0xfff4,         -1,
ALT_U           ,       0xfff5,         -1,
ALT_V           ,       0xfff6,         -1,
ALT_W           ,       0xfff7,         -1,
ALT_X           ,       0xfff8,         -1,
ALT_Y           ,       0xfff9,         -1,
ALT_Z           ,       0xfffa,         -1,

ALT_0           ,       0xffb0,         -1,
ALT_1           ,       0xffb1,         -1,
ALT_2           ,       0xffb2,         -1,
ALT_3           ,       0xffb3,         -1,
ALT_4           ,       0xffb4,         -1,
ALT_5           ,       0xffb5,         -1,
ALT_6           ,       0xffb6,         -1,
ALT_7           ,       0xffb7,         -1,
ALT_8           ,       0xffb8,         -1,
ALT_9           ,       0xffb9,         -1,

ALT_TILDA       ,       0xffe0,         -1,
ALT_MINUS_UND   ,       0xffad,         -1,
ALT_PLUS_EQ     ,       0xffbd,         -1,
ALT_LBRACKET    ,       0xffdb,         -1,
ALT_RBRACKET    ,       0xffdd,         -1,
ALT_BACKSLASH   ,       0xffdc,         -1,
ALT_COLON       ,       0xffbb,         -1,
ALT_QUOTA       ,       0xffa7,         -1,
ALT_LESSTHAN    ,       0xffac,         -1,
ALT_GREATERTHAN ,       0xffae,         -1,
ALT_QUEST_SLASH ,       0xffaf,         -1,
//
ALT_SPACE       ,       0xffa0,         -1,
ALT_BACKSPACE   ,       0xff88,         -1,
ALT_RETURN      ,       0xff8d,         -1,
//
ALT_SHIFT_A           ,       0xffc1,         -1,
ALT_SHIFT_B           ,       0xffc2,         -1,
ALT_SHIFT_C           ,       0xffc3,         -1,
ALT_SHIFT_D           ,       0xffc4,         -1,
ALT_SHIFT_E           ,       0xffc5,         -1,
ALT_SHIFT_F           ,       0xffc6,         -1,
ALT_SHIFT_G           ,       0xffc7,         -1,
ALT_SHIFT_H           ,       0xffc8,         -1,
ALT_SHIFT_I           ,       0xffc9,         -1,
ALT_SHIFT_J           ,       0xffca,         -1,
ALT_SHIFT_K           ,       0xffcb,         -1,
ALT_SHIFT_L           ,       0xffcc,         -1,
ALT_SHIFT_M           ,       0xffcd,         -1,
ALT_SHIFT_N           ,       0xffce,         -1,
ALT_SHIFT_O           ,       0xffcf,         -1,
ALT_SHIFT_P           ,       0xffd0,         -1,
ALT_SHIFT_Q           ,       0xffd1,         -1,
ALT_SHIFT_R           ,       0xffd2,         -1,
ALT_SHIFT_S           ,       0xffd3,         -1,
ALT_SHIFT_T           ,       0xffd4,         -1,
ALT_SHIFT_U           ,       0xffd5,         -1,
ALT_SHIFT_V           ,       0xffd6,         -1,
ALT_SHIFT_W           ,       0xffd7,         -1,
ALT_SHIFT_X           ,       0xffd8,         -1,
ALT_SHIFT_Y           ,       0xffd9,         -1,
ALT_SHIFT_Z           ,       0xffda,         -1,

ALT_SHIFT_0           ,       0xffa9,         -1,
ALT_SHIFT_1           ,       0xffa1,         -1,
ALT_SHIFT_2           ,       0xffc0,         -1,
ALT_SHIFT_3           ,       0xffa3,         -1,
ALT_SHIFT_4           ,       0xffa4,         -1,
ALT_SHIFT_5           ,       0xffa5,         -1,
ALT_SHIFT_6           ,       0xff9e,         -1,
ALT_SHIFT_7           ,       0xffa6,         -1,
ALT_SHIFT_8           ,       0xffaa,         -1,
ALT_SHIFT_9           ,       0xffa8,         -1,

ALT_SHIFT_TILDA       ,       0xfffe,         -1,
ALT_SHIFT_MINUS_UND   ,       0xffdf,         -1,
ALT_SHIFT_PLUS_EQ     ,       0xffab,         -1,
ALT_SHIFT_LBRACKET    ,       0xfffb,         -1,
ALT_SHIFT_RBRACKET    ,       0xfffd,         -1,
ALT_SHIFT_BACKSLASH   ,       0xfffc,         -1,
ALT_SHIFT_COLON       ,       0xffba,         -1,
ALT_SHIFT_QUOTA       ,       0xffa2,         -1,
ALT_SHIFT_LESSTHAN    ,       0xffbc,         -1,
ALT_SHIFT_GREATERTHAN ,       0xffbe,         -1,
ALT_SHIFT_QUEST_SLASH ,       0xffbf,         -1,
#endif /* 0 */
//
-1 };

short special_table[] = {
ESC             , 033,
-1};

#include "gentab.c"
