#define UNIX
#define ix86
#define NM
#include "nm.h"
#include "kb.h"
#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <sys/signal.h>
#include <fcntl.h>
unsigned char kb_buf;
unsigned char kb_flags;
local struct termios shell_termio;
local struct termios nm_termio;
int term_file;
local int term_flags;
bool have_tty;
int kbmod = 0;
#define buf_no_empty()      (kb_flags &  KBBNE )
#define set_buf_no_empty()  (kb_flags |= KBBNE )
#define buf_empty()        !(kb_flags &  KBBNE )
#define set_buf_empty()     (kb_flags &= ~KBBNE )
void
clear_tty_in ()
{
  ioctl (term_file, TCFLSH, 0);
}
#define set_flag_no_delay() (term_flags |=  O_NDELAY)
#define set_flag_delay()    (term_flags &= ~O_NDELAY)
#define is_no_delay()       (term_flags &   O_NDELAY)
#define is_delay()          !(term_flags &   O_NDELAY)

local short
get_tty ()
{
  if (buf_empty ())
    {
      if (is_no_delay ())
	{
	  set_flag_delay ();
	  fcntl (term_file, F_SETFL, term_flags);
	}
      while (read (term_file, &kb_buf, 1) != 1)
	{
	  if (qkbhbrk ())
	    {
	      kb_buf = 003;	/* CTRL_C */
	      break;
	    }
	}
    }
  set_buf_empty ();
  return ((short) kb_buf) & 0377;
}

local void
break_handler ()
{
  set_break_pressed ();
  signal (SIGINT, break_handler);
}

local void
quit_handler ()
{
  signal (SIGQUIT, quit_handler);
}
void
term_attach ()
{
  int i;
  char file_name[MAXPATH], *n, *t;
  char buf[256];
#define otkaz( s ) { puts( s ); _exit( 1 ); }

  register struct termio *st = &shell_termio;
  register struct termio *mt = &nm_termio;
  term_file = 0;
  kb_flags = 0;
  ioctl (term_file, TCGETA, mt);
  *st = *mt;
  mt->c_iflag &= ~(ISTRIP | IUCLC | ICRNL);
  mt->c_iflag |= (IXOFF | IGNBRK | IGNPAR);
  mt->c_iflag |= (IXON);
  mt->c_oflag &= ~(OPOST);
  mt->c_lflag &= ~(ICANON | ECHO | ECHOE | ECHONL);
  mt->c_lflag |= (ISIG);
  mt->c_cc[VINTR] = '\003';
  mt->c_cc[VQUIT] = '\032';
  mt->c_cc[VSWTC] = '\377';
  mt->c_cc[VMIN] = 1;
  mt->c_cc[VTIME] = 0;
  ioctl (term_file, TCSETAF, mt);
  term_flags = fcntl (term_file, F_GETFL);
  term_flags |= O_SYNC;
  fcntl (term_file, F_SETFL, term_flags);
  signal (SIGINT, break_handler);
  signal (SIGQUIT, quit_handler);
}

void
kbDetach ()
{
  int s;
  if (have_tty)
    {
      ioctl (term_file, TCSETAW, &shell_termio);
      signal (SIGINT, SIG_IGN);
      signal (SIGQUIT, SIG_IGN);
      have_tty = FALSE;
    }
}

void
kbAttach ()
{
  if (!have_tty)
    {
      signal (SIGINT, break_handler);
      signal (SIGQUIT, quit_handler);
      ioctl (term_file, TCSETAF, &nm_termio);
      kb_flags = 0;
      have_tty = TRUE;
    }
}

int
main ()
{
  short c;
  term_attach ();
  kbAttach ();
  while (1)
    {
      c = get_tty ();
      printf ("%o\n\r", c);
      if (c == 001)
	break;
    }
  kbDetach ();
}
