#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <signal.h>

struct termios shell_termio;
struct termios nm_termio;

int term_file, i;

void
break_handler ()
{
  tcsetattr (term_file, TCSADRAIN, &shell_termio);
  exit (0);
}

int
main ()
{
  register struct termios *st = &shell_termio;
  register struct termios *mt = &nm_termio;

  term_file = 0;
  tcgetattr (term_file, mt);
  *st = *mt;
  mt->c_iflag &= ~(ISTRIP | ICRNL);
  mt->c_iflag |= (IXOFF | IGNBRK | IGNPAR);
  mt->c_iflag |= (IXON);
  mt->c_oflag &= ~(OPOST);
  mt->c_lflag &= ~(ICANON | ECHO | ECHOE | ECHONL);
  mt->c_lflag |= (ISIG);
  mt->c_cc[VINTR] = '\003';
  mt->c_cc[VQUIT] = '\377';
  mt->c_cc[VMIN] = 1;
  mt->c_cc[VTIME] = 0;
  tcsetattr (term_file, TCSADRAIN, mt);
  signal (SIGINT, break_handler);
  while (1)
    {
      char k;

      if ((i = read (term_file, &k, 1)) == 0)
	continue;
      printf ("%o %c\n\r", k, (k >= 040) ? k : 040);
    }
  return 0;
}
