/*
 *     nanoMir
 *
 *     "nm.c"           Runner       
 */

#include <stdio.h>
#include <signal.h>
#ifdef VMS
#include <types.h>
#else
#include <sys/types.h>
#include <unistd.h>
#endif

#include "nm.h"
#include "sw.h"
#include "fs.h"
#include "dq.h"
#include "tx.h"
#include "me.h"
#include "wd.h"
#ifndef X11
#include "sc.h"
#endif
#include "kb.h"
#include "le.h"
#include "te.h"
#include "ud.h"
#include "cm.h"
#include "tm.h"
#include "er.h"

extern void dbprintf ();
extern char *getenv (char *);
jmp_buf *excptr = (jmp_buf *) NIL;	/*               */
char Event[E_MAX];		/*                           */

local void
sigme0 (int i)			/*    0( <> ) */
{
  signal (i, sigme0);
}

local void
sigme1 (int i)			/*    1( <> ) */
{
  signal (i, sigme1);
  tmSaveAll ();			/*                */
  kbAttach ();			/*  .        */
#ifndef X11
  scAttach ();			/*  .             */
  scErase ();			/*  .              */
#endif
}

sigInit ()
{				/*   .  */
  signal (SIGQUIT, sigme0);
  signal (SIGINT, sigme0);
}

void
nmInit ()			/*  .        */
{
  char *p;
  asctosw (nmswitch);		/*      */
  if (p = getenv (MIMOPT))
    asctosw (p);		/*      */
  /*                  */
  erInit ();			/*  .         */
  kbInit ();			/*  .     */
#ifndef X11
  scInit ();			/*  .          */
#endif
  txInit ();			/*  .         */
  fsInit ();			/*  .             */
  wdInit ();			/*  .           */
  leInit ();			/*   .  */
  teInit ();			/*   .  */
  tmInit ();			/*  .             */
  udInit ();			/*  .        */
  cpInit ();			/*  .    */
/**********/
  meInit ();			/*  .             */
  dqInit ();			/*  .           */
  {				/*     */
    register int i;
    for (i = 0; i < E_MAX; i++)
      Event[i] = FALSE;
    Event[E_OK] = TRUE;
    Event[E_NOCOM] = TRUE;
    Event[E_DOWN] = TRUE;
    Event[E_UP] = TRUE;
    Event[E_CHANGE] = TRUE;
    Event[E_EDTEND] = TRUE;
    Event[E_MOVEND] = TRUE;
    excptr = NIL;
  }
}

void
nmTerm ()
{
#ifndef X11
  ScTerm ();
#endif
  KbTerm ();
}

void
exc (small code)
{				/*  ( <> )   */
  if (excptr == NIL)
    otkaz ("EXC");
  longjmp (*excptr, code);
}

int
main (small argc, register char **argp, char **envp)
{

#if 1 /*      */
#ifdef X11
#ifdef GLIBC2
  if (daemon (1, 1))
    {
      write (STDERR_FILENO, "Cannot put itself in background!\n", 33);
      return -1;
    }
#else
  {
    int res = fork ();

    if (res == -1)
      {
        write (STDERR_FILENO, "Cannot fork!\n", 13);
      }
    else if (res != 0)
      {
        /* Parent process: terminate */
        return 0;
      }
    /* Child process (res == 0) continues */
  }
#endif /* GLIBC2 */
#endif /* X11 */
#endif

#ifdef COLOR
  InitTermColors ();
#endif

  sigInit ();
  nmInit ();
  if (argc >= 2)
    {
      if (!wmInit (*(++argp)))
	goto err;
    }
  else if (!wmInit (ROOTFILE))
    goto err;

  /*    */
  stOn ();

  wmEdit ();
#ifdef COLOR
  SetDefaultTextColor ();
#endif
  return 0;
err:
  nmTerm ();
}

tchar *
NoInfo (wnd * w, small y, small * pl)	/*    */
{
  *pl = 0;
  return (NIL);
}

void
dbprintf (fmt, p1, p2, p3, p4, p5)
     char *fmt;
     addr p1, p2, p3, p4, p5;
{
  fprintf (stderr, fmt, p1, p2, p3, p4, p5);
}

void
otkaz (char *p)
{
  dbprintf ("Otkaz - %s\n", p);
#ifdef COLOR
  SetDefaultTextColor ();
#endif
#ifdef X11
  stufTerm ();
#else
  scDetach ();
#endif
  kbDetach ();
#ifdef COLOR
  SetDefaultTextColor ();
#endif
  exit (1);
}
