/*
 *     nanoMir
 *
 *     "sw.c"           Switcher
 */


#include "nm.h"
#include "sw.h"
#include "fs.h"
#include "dq.h"
#include "tx.h"
#include "me.h"
#include "wd.h"
#include "kb.h"
#include "le.h"
#include "te.h"
#include "ud.h"
#include "cm.h"
#include "tm.h"
#ifdef SPELL
#include "er.h"
#endif

char clibpath[MAXPATH], nmlocal[MAXPATH] = DEFAULT_MIMTERMINFO;

char nmswitch[256] =                    /*                 */
#ifdef UNIX
"a b c/usr/include/  i+ k5 m400 n64 p0 q65 r v+ w x/usr/local/lib/mim/";
/*"a b c/usr/include/  i+ k3 m400 n64 p0 q63 v+ w x/usr/local/nmlib/";*/
/* "a b c/usr/include/  i- k3 m400 n64 p0 q63 v- w x/usr/local/nmlib/"; */
#endif
#ifdef VMS
"a b csys$library: i+ k3 m400 p0 q63 v+ w xnm$lib:";
/* "a b csys$library: i- k3 m400 p0 q63 v- w xnm$lib:"; */
#endif
static swt swtchs[MAXSWT] = {
/*a*/ SW_BOOL , (void *)&Tradjust,      /*          */
/*b*/ SW_BOOL , (void *)&Lwp,           /*         */
/*c*/ SW_CHAR , (void *)clibpath,       /*   #include-   */
/*d*/ SW_NONE , NIL,                    /*                                 */
/*e*/ SW_CHAR , (void *)fsDefExt,       /*       */
/*f*/ SW_NONE , NIL,                    /*                                 */
/*g*/ SW_NONE , NIL,                    /*                                 */
/*h*/ SW_NONE , NIL,                    /*                                 */
/*i*/ SW_BOOL , (void *)&Lrins,         /*                     */
/*j*/ SW_NONE , NIL,                    /*                                 */
/*k*/ SW_SMALL, (void *)&fpl1m,   /*     */
/*l*/ SW_NONE , NIL,                    /*                                 */
/*m*/ SW_NONE , NIL,                    /*          */
/*n*/ SW_NONE , NIL,
/*o*/ SW_NONE , NIL,
/*p*/ SW_SMALL, (void *)&fplm,    /*      */
/*q*/ SW_SMALL, (void *)&fprm,    /*     */
/*r*/ SW_BOOL , (void *)&mechMathReturn,/* Return    */
#ifdef SPELL
/*s*/ SW_CHAR , (void *)spellfile,      /*                    */
#else
/*s*/ SW_NONE , NIL,
#endif
/*t*/ SW_SMALL, (void *)&TX_TabSize,	/*  		   */
/*u*/ SW_BOOL , (void *)&TX_ReplaceSpacesByTabs, /*     */
/*v*/ SW_BOOL , (void *)&tecss,         /* Case sensitive search           */
/*w*/ SW_BOOL , (void *)&Twwrap,        /*                 */
/*x*/ SW_CHAR , (void *)nmlocal,   /*      */
/*y*/ SW_NONE , NIL,
/*z*/ SW_NONE , NIL,
};

char *
swtoasc (register char *p)
{				/* Convert switches to ASCII string */
  register swt *psw;
  register small i;

  for (i = 0, psw = swtchs; i < MAXSWT; i++, psw++)
    if (psw->swtype != SW_NONE)
      {
	if (i != 0)
	  *p++ = ' ';
	*p++ = 'a' + i;
	switch (psw->swtype)
	  {
	  case SW_BOOL:
	    if (!*(bool *) (psw->swvar))
	      *p++ = '-';
	    break;
	  case SW_CHAR:
	    p = scpy ((char *) (psw->swvar), p);
	    break;
	  case SW_SMALL:
	    p = stod (p, *(small *) (psw->swvar));
	    break;
	  }
      }
  return (p);
}

char *
asctosw (register char *p)
{				/* Convert ASCII string to switches */
  register swt *psw;
  register char *po;
  register small i;

  for (;;)
    {
      while ((i = *p++) == ' ' || i == '-');
      if (i == 0)
	break;
      if ((i -= 'a') >= 0 && i < MAXSWT)
	{
	  psw = swtchs + i;
	  switch (psw->swtype)
	    {
	    case SW_BOOL:
	      i = FALSE;
	      if (*p++ != '-')
		{
		  i = TRUE;
		  p--;
		}
	      *(bool *) (psw->swvar) = i;
	      break;
	    case SW_CHAR:
	      po = p;
	      while ((i = *p++) != 0 && i != ' ');
	      p--;
	      *sncpy (po, (char *) (psw->swvar), (small) (p - po)) = 0;
	      break;
	    case SW_SMALL:
	      p = dtos (p, (small *) (psw->swvar));
	      break;
	    }
	}
    }
  return (p);
}
