/*
 *     nanoMir
 *
 *     "xi.c"           X-interface
 */

#include <stdio.h>
#include <stdlib.h>
#include "nm.h"
#include "te.h"
#include "le.h"
#include "xi.h"
#include "wd.h"
#include "trm.h"
#include "db.h"
#include "cmn.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>

/* #define XIDEBUGEVENT */

#ifdef XIDEBUGEVENT
#include "xevent.h"
#endif
#include "xnm.icon"
#include "up_arrow.bitmap"
#include "down_arrow.bitmap"
#include "slider.bitmap"

#include "xi_keys.h"
#include "er.h"

#define XPX( x ) ((x)*wInc)
#define XPY( y ) ((y)*hInc)
#define WPX( x ) ((x)/wInc)
#define WPY( y ) ((y)/hInc)

#define WINIDNAME  "NMWINDOW"
#define WINTIDNAME "NMTYPEOFWINDOW"
#define WINTYPNAME "NMWINDOWTYPE"
#define WTI_WINDOW    1
#define WTI_MAIN      2
#define WTI_SCROLLBAR 3
#define WTI_STATUSBAR 4

#define ARW_WIDTH  up_arrow_width
#define ARW_HEIGHT up_arrow_height

#define SCB_BORDER 2
#define SCB_WIDTH (ARW_WIDTH + 2 * SCB_BORDER)
#define SCB_PAD    5

#define SLD_WIDTH  ARW_WIDTH
#define SLD_MIN_HEIGHT 30

#ifdef STATUS_IN_MAIN_WINDOW
#define STATUS_WINDOW_HEIGHT    (XPY (NSTLINE))
#define STATUS_WINDOW_PAD       (2 * pad)
/* #define STATUS_WINDOW_PAD       (0) */
#endif

bool xiLocked = FALSE;

/* Code for F5, see keyboard description for X11 */
#define XI_KEY_START_BLOCK	(0x2ff & XK_F5)

/*  ,     .
       -     
     . */
/* #define MARK_BLOCK_BY_MOUSE */

void
ScJustMin ()
{
}

local unsigned long getPlane (unsigned long f, unsigned long g);
local bool xiHandleEvent (XEvent * e);
local void tuneColor (color * c);
local int eioHandler (Display * dpy);
local bool checkKeyBuf (void);
local void handleScroll (small dir);

Display *dpy;
local Window root;
local Pixmap iPixmap, upaPixmap, downaPixmap, sliderPixmap;
local int scr;
local int depth;
local Colormap cmap;
local bool focus = FALSE;
wnd *xiTWnd;
local small borderWidth = 0;
struct dbvalue dbBorderWidth = { &borderWidth, FALSE };
local small pad = 2;
struct dbvalue dbPad = { &pad, FALSE };

/* local bool scrollbarOn = TRUE; */
local bool scrollbarOn = FALSE;

struct dbvalue dbscbOn = { &scrollbarOn, FALSE };
local small scrollDir = 0;

local color foreground, background;
struct dbvalue dbForeground = { foreground.name, FALSE };
struct dbvalue dbBackground = { background.name, FALSE };
local color tcforeground, tcbackground;
struct dbvalue dbTcForeground = { tcforeground.name, FALSE };
struct dbvalue dbTcBackground = { tcbackground.name, FALSE };
local color stforeground, stbackground;
struct dbvalue dbStForeground = { stforeground.name, FALSE };
struct dbvalue dbStBackground = { stbackground.name, FALSE };
local color erforeground, erbackground;
struct dbvalue dbErForeground = { erforeground.name, FALSE };
struct dbvalue dbErBackground = { erbackground.name, FALSE };
local color icforeground, icbackground;
struct dbvalue dbIcForeground = { icforeground.name, FALSE };
struct dbvalue dbIcBackground = { icbackground.name, FALSE };

local GC gc, igc, tccgc, tcsgc, stgc, ergc;

local char fontName[128] = { DEFAULT_XMIMFONT };

struct dbvalue dbFontName = { fontName, FALSE };
local XFontStruct *textFont;
local short wInc;
local int hInc;
local short descent;
local short ascent;
local Atom winID, winTID, winTyp;

local Atom winProtocolsAtom = 0;
local Atom winDeleteWindowAtom = 0;

local unsigned long cplane, splane;
local XSetWindowAttributes mncattr, sbcattr, slcattr, aucattr, adcattr,
  stcattr, ercattr, iattr;
local unsigned long mncmask, sbcmask, slcmask, aucmask, adcmask, stcmask,
  ercmask;
#if 0
local long eventMask = 0xffffff;
#else
local long eventMask = ExposureMask | StructureNotifyMask | KeyPressMask |
  ButtonPressMask | ButtonReleaseMask | 
#ifdef MARK_BLOCK_BY_MOUSE
  Button1MotionMask | PointerMotionHintMask |
#endif
  FocusChangeMask | EnterWindowMask | LeaveWindowMask;
#endif
unsigned short xiKey;
small xiTx;
large xiTy;
local unsigned int specButton = Button1;
int stdX = 0, stdY = 0, stdHeight = 25, stdWidth = 80;
int stX = 0, stY = 0;
int stdIX = 0, stdIY = 0;
local char Geostr[128], iconGeostr[128];
struct dbvalue dbGeostr = { Geostr, FALSE };
struct dbvalue dbIconGeostr = { iconGeostr, FALSE };
local bool userGeo, userIconGeo;
local char defGeostr[] = { "80x25" };
local char defIGeostr[] = { "" };
local unsigned char *keyBuf, *keyPtr;
local unsigned long keyN;

/*      (x0, y0), (x1, y1) */
local void xiBlkRedraw (wnd * w, small x0, small x1, small y0, small y1);

#define otkaz( str ) { printf( "xmim: %s\n", str ); _exit( 1 ); }

void
xiAttach ()
{
  unsigned long flags;
  XColor c;
  XGCValues gcv;
  Cursor cursor, sbcursor;
  int t;
  dpy = XOpenDisplay ("");
  if (!dpy)
    otkaz ("open display fail");
#if 0
  XSynchronize (dpy, True);
#endif
  XSetIOErrorHandler (eioHandler);
  scr = DefaultScreen (dpy);
  root = DefaultRootWindow (dpy);
  depth = DefaultDepth (dpy, scr);
  cmap = DefaultColormap (dpy, scr);

  {
    char *envStr;

    envStr = getenv (XMIMFOREGROUND);
    if (envStr == NULL || strcmp (envStr, "") == 0)
      {
	*scpy (DEFAULT_XMIMFOREGROUND, foreground.name) = 0;
      }
    else
      {
	*scpy (envStr, foreground.name) = 0;
      }

    envStr = getenv (XMIMBACKGROUND);
    if (envStr == NULL || strcmp (envStr, "") == 0)
      {
	*scpy (DEFAULT_XMIMBACKGROUND, background.name) = 0;
      }
    else
      {
	*scpy (envStr, background.name) = 0;
      }

    envStr = getenv (XMIMFONT);
    if (envStr != NULL && strcmp (envStr, "") != 0)
      {
	strcpy (fontName, envStr);
      }

    envStr = getenv (XMIMSTFOREGROUND);
    if (envStr == NULL || strcmp (envStr, "") == 0)
      {
	*scpy (DEFAULT_XMIMSTFOREGROUND, stforeground.name) = 0;
      }
    else
      {
	*scpy (envStr, stforeground.name) = 0;
      }

    envStr = getenv (XMIMSTBACKGROUND);
    if (envStr == NULL || strcmp (envStr, "") == 0)
      {
	*scpy (DEFAULT_XMIMSTBACKGROUND, stbackground.name) = 0;
      }
    else
      {
	*scpy (envStr, stbackground.name) = 0;
      }

    *scpy (background.name, tcforeground.name) = 0;
    *scpy (foreground.name, tcbackground.name) = 0;

    *scpy (background.name, erforeground.name) = 0;
    *scpy (foreground.name, erbackground.name) = 0;

    *scpy (background.name, icforeground.name) = 0;
    *scpy (foreground.name, icbackground.name) = 0;
    dbGetPreferences ();
  }

  tuneColor (&foreground);
  tuneColor (&background);

  tuneColor (&tcforeground);
  tuneColor (&tcbackground);

  tuneColor (&stforeground);
  tuneColor (&stbackground);

  tuneColor (&erforeground);
  tuneColor (&erbackground);

  tuneColor (&icforeground);
  tuneColor (&icbackground);

  /*+++
     printf("Loading font: %s\n", fontName);
     +++ */

  textFont = XLoadQueryFont (dpy, fontName);
  if (textFont == NULL)
    {
      printf ("Cannot load font: %s\n", fontName);
      /* Try some fixed font (added by VVB) */
      strcpy (fontName,
	      /* "-adobe-courier-bold-r-normal--14-140-75-75-m-90-iso8859-1" */
	      /* "-*-courier-bold-r-normal--14-*-*-*-*-*-*-*" */
	      "-*-courier-bold-r-normal--17-*-*-*-*-*-*-*");
      printf ("Loading font: %s\n", fontName);
      textFont = XLoadQueryFont (dpy, fontName);
    }
  if (!textFont)
    otkaz ("Load font failed");
  wInc = textFont->max_bounds.width;
  ascent = textFont->ascent;
  descent = textFont->descent;
  hInc = ascent + descent;

  splane = getPlane (foreground.pix, background.pix);
  cplane = getPlane (tcforeground.pix, tcbackground.pix);

  gcv.foreground = foreground.pix;
  gcv.background = background.pix;
  gcv.font = textFont->fid;
  flags = GCForeground | GCBackground | GCFont;
  gc = XCreateGC (dpy, root, flags, &gcv);

  gcv.foreground = background.pix;
  gcv.background = foreground.pix;
  igc = XCreateGC (dpy, root, flags, &gcv);

  gcv.foreground = stforeground.pix;
  gcv.background = stbackground.pix;
  flags = GCForeground | GCBackground | GCFont;
  stgc = XCreateGC (dpy, root, flags, &gcv);

  gcv.foreground = erforeground.pix;
  gcv.background = erbackground.pix;
  flags = GCForeground | GCBackground | GCFont;
  ergc = XCreateGC (dpy, root, flags, &gcv);

  if (foreground.pix & splane)
    {
      gcv.foreground = tcforeground.pix;
      gcv.background = tcbackground.pix;
    }
  else
    {
      gcv.foreground = tcbackground.pix;
      gcv.background = tcforeground.pix;
    }
  gcv.graphics_exposures = False;
  flags = GCForeground | GCBackground | GCGraphicsExposures;
  tcsgc = XCreateGC (dpy, root, flags, &gcv);
  if (tcforeground.pix & cplane)
    {
      gcv.foreground = foreground.pix;
      gcv.background = background.pix;
    }
  else
    {
      gcv.foreground = background.pix;
      gcv.background = foreground.pix;
    }
  upaPixmap = XCreatePixmapFromBitmapData (dpy, root, up_arrow_bits,
					   up_arrow_width, up_arrow_height,
					   foreground.pix, background.pix,
					   depth);
  downaPixmap =
    XCreatePixmapFromBitmapData (dpy, root, down_arrow_bits, down_arrow_width,
				 down_arrow_height, foreground.pix,
				 background.pix, depth);
  sliderPixmap =
    XCreatePixmapFromBitmapData (dpy, root, slider_bits, slider_width,
				 slider_height, foreground.pix,
				 background.pix, depth);
  tccgc = XCreateGC (dpy, root, flags, &gcv);
  cursor = XCreateFontCursor (dpy, XC_xterm);
  XRecolorCursor (dpy, cursor, &foreground.xcolor, &background.xcolor);
  sbcursor = XCreateFontCursor (dpy, XC_top_left_arrow);
  XRecolorCursor (dpy, sbcursor, &background.xcolor, &foreground.xcolor);
  mncattr.background_pixel = background.pix;
  mncattr.border_pixel = background.pix;
  mncattr.bit_gravity = StaticGravity;
  mncattr.cursor = cursor;
  mncmask = CWBackPixel | CWBorderPixel | CWBitGravity | CWCursor;
  sbcattr.background_pixel = background.pix;
  sbcattr.border_pixel = foreground.pix;
  sbcattr.bit_gravity = StaticGravity;
  sbcattr.cursor = sbcursor;
  sbcmask = CWBackPixel | CWBorderPixel | CWBitGravity | CWCursor;
  slcattr.background_pixel = foreground.pix;
  slcattr.border_pixel = foreground.pix;
  slcattr.bit_gravity = StaticGravity;
  slcattr.cursor = sbcursor;
  slcmask = CWBackPixel | CWBorderPixel | CWBitGravity | CWCursor;
  aucattr.background_pixel = background.pix;
  aucattr.border_pixel = foreground.pix;
  aucattr.bit_gravity = StaticGravity;
  aucattr.win_gravity = NorthGravity;
  aucattr.cursor = sbcursor;
  aucmask =
    CWBackPixel | CWBorderPixel | CWBitGravity | CWWinGravity | CWCursor;
  adcattr.background_pixel = background.pix;
  adcattr.border_pixel = foreground.pix;
  adcattr.bit_gravity = StaticGravity;
  adcattr.win_gravity = SouthGravity;
  adcattr.cursor = sbcursor;
  adcmask =
    CWBackPixel | CWBorderPixel | CWBitGravity | CWWinGravity | CWCursor;
  stcattr.background_pixel = stbackground.pix;
  stcattr.border_pixel = stbackground.pix;
  stcattr.bit_gravity = StaticGravity;
  stcattr.override_redirect = True;
  stcmask = CWBackPixel | CWBorderPixel | CWBitGravity | CWOverrideRedirect;
  ercattr.background_pixel = erbackground.pix;
  ercattr.border_pixel = erbackground.pix;
  ercattr.bit_gravity = StaticGravity;
  ercattr.override_redirect = True;
  ercmask = CWBackPixel | CWBorderPixel | CWBitGravity | CWOverrideRedirect;

  {
    int flags;
    flags = XGeometry (dpy, scr, Geostr, defGeostr, 0, wInc, hInc,
		       pad, pad, &stdX, &stdY, &stdWidth, &stdHeight);
    userGeo = dbGeostr.dbv_changed && ((flags & XValue) || (flags & YValue));
    flags = XGeometry (dpy, scr, iconGeostr, defIGeostr, 0, 1, 1, 0, 0,
		       &stdIX, &stdIY, &t, &t);
    userIconGeo = dbGeostr.dbv_changed && ((flags & XValue)
					   || (flags & YValue));
  }

  /*  XGeometry     , 
       stdX, stdY, stdIX, stdIY */
  {
    XWindowAttributes rAttributes;

    if (XGetWindowAttributes (dpy, root, &rAttributes))
      {
	int nRootWWidth = rAttributes.width;
	int nRootWHeight = rAttributes.height;
	int nWWidth = XPX (stdWidth);
	int nWHeight = XPY (stdHeight);

	/*   */
	stdX = (nRootWWidth - nWWidth) / 2;
	stdY = (nRootWHeight - nWHeight) / 2;
	stdIX = 0;
	stdIY = 0;
      }
  }

  iPixmap = XCreatePixmapFromBitmapData (dpy, root, icon_bits,
					 icon_width, icon_height,
					 icforeground.pix, icbackground.pix,
					 depth);
  winID = XInternAtom (dpy, WINIDNAME, False);
  winTID = XInternAtom (dpy, WINTIDNAME, False);
  winTyp = XInternAtom (dpy, WINTYPNAME, False);

  //     Windows Manager
  winProtocolsAtom = XInternAtom (dpy, "WM_PROTOCOLS", False);
  winDeleteWindowAtom = XInternAtom(dpy, "WM_DELETE_WINDOW", False);

  keyBuf = keyPtr = NIL;
  keyN = 0;
}

local void
tuneColor (color * c)
{
  XParseColor (dpy, cmap, c->name, &c->xcolor);
  XAllocColor (dpy, cmap, &c->xcolor);
}

local unsigned long
getPlane (unsigned long f, unsigned long b)
{
  register int i;
  unsigned long g = f ^ b, p = 1;

  for (i = 0; i < depth; i++)
    if (g & 1)
      return 1 << i;
    else
      g >>= 1;
  return 1;
}

local int
eioHandler (Display * dpy)
{
  /*       .
       X11   .
           ,
            . */
  tmSaveBackAll ();
}

void
xiDetach ()
{
  XCloseDisplay (dpy);
}

bool xiCreateWindow (wnd * w)
{
  int sx, sy, sw, sh;
  XSetWindowAttributes *attr;
  unsigned long mask;
  long em;
  large dw, wti;
  XWMHints wmHints;
  XSizeHints szHints;
  XClassHint clHints;
  sx = w->wsx;
  sy = w->wsy;
  sw = XPX (w->wsw);
  sh = XPY (w->wsh);
  switch (w->wtyp)
    {
    case WND_STATUS:
      attr = &stcattr;
      mask = stcmask;
      em = ExposureMask;
      w->wxgc = stgc;
      w->wxigc = stgc;
      break;
    case WND_ERROR:
      attr = &ercattr;
      mask = ercmask;
      em = ExposureMask | KeyPressMask | ButtonPressMask;
      w->wxgc = ergc;
      w->wxigc = ergc;
      break;
    case WND_NORMAL:
      attr = &mncattr;
      mask = mncmask;
      w->wxgc = gc;
      w->wxigc = igc;
      em = eventMask;
      break;
    }
  if (w->wtyp == WND_NORMAL && scrollbarOn)
#ifdef STATUS_IN_MAIN_WINDOW
    w->wxwin = XCreateWindow (dpy, root, sx, sy,
			      sw + 2 * pad + SCB_WIDTH + SCB_PAD,
			      sh + 2 * pad + STATUS_WINDOW_HEIGHT +
			      STATUS_WINDOW_PAD, borderWidth, CopyFromParent,
			      InputOutput, CopyFromParent, mask, attr);
#else
    w->wxwin = XCreateWindow (dpy, root, sx, sy,
			      sw + 2 * pad + SCB_WIDTH + SCB_PAD,
			      sh + 2 * pad, borderWidth, CopyFromParent,
			      InputOutput, CopyFromParent, mask, attr);
#endif /* STATUS_IN_MAIN_WINDOW */
#ifdef STATUS_IN_MAIN_WINDOW
  else if (w->wtyp == WND_NORMAL)
    w->wxwin = XCreateWindow (dpy, root, sx, sy,
			      sw + 2 * pad,
			      sh + 2 * pad + STATUS_WINDOW_HEIGHT +
			      STATUS_WINDOW_PAD, borderWidth, CopyFromParent,
			      InputOutput, CopyFromParent, mask, attr);
  else if (w->wtyp == WND_STATUS)
    w->wxwin = Twnd->wxwin;
  else
#endif /* STATUS_IN_MAIN_WINDOW */
    w->wxwin = XCreateWindow (dpy, root, sx, sy,
			      sw + 2 * pad, sh + 2 * pad,
			      borderWidth, CopyFromParent, InputOutput,
			      CopyFromParent, mask, attr);
#ifdef STATUS_IN_MAIN_WINDOW
  if (w->wtyp == WND_NORMAL)
    {
      w->wxstatusbar =
	XCreateWindow (dpy, w->wxwin, 0, 0, sw,
		       STATUS_WINDOW_HEIGHT + STATUS_WINDOW_PAD, pad,
		       CopyFromParent, InputOutput, CopyFromParent, stcmask,
		       &stcattr);
      w->wxmain =
	XCreateWindow (dpy, w->wxwin, 0,
		       STATUS_WINDOW_HEIGHT + STATUS_WINDOW_PAD, sw, sh, pad,
		       CopyFromParent, InputOutput, CopyFromParent, mask,
		       attr);
    }
  else if (w->wtyp == WND_STATUS)
    {
      w->wxmain = Twnd->wxstatusbar;
      w->wsx = 0;
      w->wsy = 0;
      w->wsw = Twnd->wsw;
      w->wsh = NSTLINE;
    }
  else
#endif /* STATUS_IN_MAIN_WINDOW */
    w->wxmain = XCreateWindow (dpy, w->wxwin, 0, 0, sw, sh, pad,
			       CopyFromParent, InputOutput, CopyFromParent,
			       mask, attr);
  w->wxcx = 0;
  w->wxcy = 0;
  w->wxstat = WDX_REDRAW & ~(WDX_CACTIVE | WDX_CON);
  /*      */
  w->block_active = 0;
  w->block.x0 = 0;
  w->block.y0 = 0;
  w->block.x1 = 0;
  w->block.y1 = 0;

#ifdef STATUS_IN_MAIN_WINDOW
  if (w->wtyp == WND_STATUS)
    return;
#endif /* STATUS_IN_MAIN_WINDOW */

  if (w->wtyp == WND_NORMAL)
    {
      if (scrollbarOn)
	{
	  w->wxsb.sbmain = XCreateWindow (dpy, w->wxwin, sw + 2 * pad +
					  SCB_BORDER, pad + SCB_BORDER,
					  SCB_WIDTH - 2 * SCB_BORDER,
					  sh - 2 * SCB_BORDER, SCB_BORDER,
					  CopyFromParent, InputOutput,
					  CopyFromParent, sbcmask, &sbcattr);
	  w->wxsb.sbarrowup =
	    XCreateWindow (dpy, w->wxsb.sbmain, 0, 0, ARW_WIDTH, ARW_HEIGHT,
			   0, CopyFromParent, InputOutput, CopyFromParent,
			   aucmask, &aucattr);
	  w->wxsb.sbarrowdown =
	    XCreateWindow (dpy, w->wxsb.sbmain, 0,
			   sh - 2 * SCB_BORDER - ARW_HEIGHT, ARW_WIDTH,
			   ARW_HEIGHT, 0, CopyFromParent, InputOutput,
			   CopyFromParent, adcmask, &adcattr);
	  w->wxsb.sbslider =
	    XCreateWindow (dpy, w->wxsb.sbmain, 0, ARW_HEIGHT, SLD_WIDTH,
			   SLD_MIN_HEIGHT, 0, CopyFromParent, InputOutput,
			   CopyFromParent, slcmask, &slcattr);
	}
      wmHints.input = True;
      wmHints.initial_state = NormalState;
      wmHints.icon_pixmap = iPixmap;
      wmHints.flags = InputHint | StateHint | IconPixmapHint;
      if (userIconGeo)
	{
	  wmHints.icon_x = stdIX;
	  wmHints.icon_y = stdIY;
	  wmHints.flags |= IconPositionHint;
	}
      szHints.x = sx;
      szHints.y = sy;
      szHints.width = sw + 2 * pad;
      szHints.height = sh + 2 * pad;
      szHints.width_inc = wInc;
      szHints.height_inc = hInc;
      szHints.min_width = 2 * pad + SCB_WIDTH + SCB_PAD + wInc;
      szHints.min_height = 2 * pad + 2 * SCB_BORDER + hInc;
      if (userGeo)
	szHints.flags = USPosition;
      else
	szHints.flags = PPosition;
      szHints.flags |= USSize | PResizeInc | PMinSize;
      clHints.res_name = NMNAME;
      clHints.res_class = NMCLASS;

#ifdef X11R3
      XSetStandardProperties (dpy, w->wxwin, NMFULLNAME, NMNAME, None, NIL, 0,
			      &szHints);
      XSetWMHints (dpy, w->wxwin, &wmHints);
      XSetClassHint (dpy, w->wxwin, &clHints);
#endif
#ifdef X11R4
      {
	XTextProperty wName, iName;
	char *wcName = NMFULLNAME, *icName = NMNAME;
	XStringListToTextProperty (&wcName, 1, &wName);
	XStringListToTextProperty (&icName, 1, &iName);
	XSetWMProperties (dpy, w->wxwin, &wName, &iName, NIL, 0,
			  &szHints, &wmHints, &clHints);
      }
#endif
    }
  dw = wdDesc (w);
  XChangeProperty (dpy, w->wxwin, winID, winTyp, 32, PropModeAppend,
		   (unsigned char *) &dw, 1);
  wti = WTI_WINDOW;
  XChangeProperty (dpy, w->wxwin, winTID, winTyp, 32, PropModeAppend,
		   (unsigned char *) &wti, 1);
  XChangeProperty (dpy, w->wxmain, winID, winTyp, 32, PropModeAppend,
		   (unsigned char *) &dw, 1);
#ifdef STATUS_IN_MAIN_WINDOW
  if (w->wtyp == WND_NORMAL)
    XChangeProperty (dpy, w->wxstatusbar, winID, winTyp, 32, PropModeAppend,
		     (unsigned char *) &dw, 1);
#endif /* STATUS_IN_MAIN_WINDOW */
  wti = WTI_MAIN;
  XChangeProperty (dpy, w->wxmain, winTID, winTyp, 32, PropModeAppend,
		   (unsigned char *) &wti, 1);
#ifdef STATUS_IN_MAIN_WINDOW
  wti = WTI_STATUSBAR;
  if (w->wtyp == WND_NORMAL)
    XChangeProperty (dpy, w->wxstatusbar, winTID, winTyp, 32, PropModeAppend,
		     (unsigned char *) &wti, 1);
#endif /* STATUS_IN_MAIN_WINDOW */
  XSelectInput (dpy, w->wxwin, em);
  XSelectInput (dpy, w->wxmain, em);
#ifdef STATUS_IN_MAIN_WINDOW
  if (w->wtyp == WND_NORMAL)
    XSelectInput (dpy, w->wxstatusbar, ExposureMask);
#endif /* STATUS_IN_MAIN_WINDOW */
  XMapRaised (dpy, w->wxwin);
  XMapRaised (dpy, w->wxmain);
#ifdef STATUS_IN_MAIN_WINDOW
  if (w->wtyp == WND_NORMAL)
    XMapRaised (dpy, w->wxstatusbar);
#endif /* STATUS_IN_MAIN_WINDOW */
  if (w->wtyp == WND_NORMAL && scrollbarOn)
    {
      XChangeProperty (dpy, w->wxsb.sbmain, winID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &dw, 1);
      wti = WTI_SCROLLBAR;
      XChangeProperty (dpy, w->wxsb.sbmain, winTID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &wti, 1);
      XChangeProperty (dpy, w->wxsb.sbslider, winID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &dw, 1);
      XChangeProperty (dpy, w->wxsb.sbslider, winTID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &wti, 1);
      XChangeProperty (dpy, w->wxsb.sbarrowup, winID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &dw, 1);
      XChangeProperty (dpy, w->wxsb.sbarrowup, winTID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &wti, 1);
      XChangeProperty (dpy, w->wxsb.sbarrowdown, winID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &dw, 1);
      XChangeProperty (dpy, w->wxsb.sbarrowdown, winTID, winTyp, 32,
		       PropModeAppend, (unsigned char *) &wti, 1);
      XSelectInput (dpy, w->wxsb.sbmain, em);
      XSelectInput (dpy, w->wxsb.sbslider, em);
      XSelectInput (dpy, w->wxsb.sbarrowup, em);
      XSelectInput (dpy, w->wxsb.sbarrowdown, em);
      XMapRaised (dpy, w->wxsb.sbmain);
      XMapRaised (dpy, w->wxsb.sbarrowup);
      XMapRaised (dpy, w->wxsb.sbslider);
      XMapRaised (dpy, w->wxsb.sbarrowdown);
    }
  /* XMapSubwindows (dpy, w->wxwin); */

  // ,    ""   
  XSetWMProtocols (dpy, w->wxwin, &winDeleteWindowAtom, 1);

#if 0
  XSync (dpy, False);
#endif
}

void
xiChangeName (wnd * w, char *name)
{
  XTextProperty tProp;
  XStringListToTextProperty (&name, 1, &tProp);
  XSetWMName (dpy, w->wxwin, &tProp);
}

void
xiChangeIconName (wnd * w, char *name)
{
  XTextProperty tProp;
  XStringListToTextProperty (&name, 1, &tProp);
  /*     ,    ,
        */
  XSetWMIconName (dpy, w->wxwin, &tProp);
}

void
xiTranslateCoord (wnd * w, int *px, int *py)
{
  Window t;
  XTranslateCoordinates (dpy, w->wxmain, root, XPX (*px), XPY (*py),
			 px, py, &t);
}

local Bool
isWindowEvent (Display * dpy, XEvent * e, XPointer arg)
{
  if (*(Window *) arg == e->xany.window)
    return True;
  return False;
}

local void
destroyWindowID (Window wID)
{
  XEvent e;
  XUnmapWindow (dpy, wID);
  XDestroyWindow (dpy, wID);
  XSync (dpy, False);		/* do not remove the call */
  while (XCheckIfEvent (dpy, &e, isWindowEvent, (XPointer) & wID));
}

void
xiDestroyWindow (wnd * w)
{
  if (xiLocked)
    xiUnLock (TRUE);
#ifdef STATUS_IN_MAIN_WINDOW
  if (w->wtyp == WND_STATUS)
    return;
  if (w->wtyp == WND_NORMAL)
    {
      destroyWindowID (w->wxstatusbar);
      w->wxstatusbar = 0;
    }
#endif /* STATUS_IN_MAIN_WINDOW */
  destroyWindowID (w->wxmain);
  if (w->wtyp == WND_NORMAL && scrollbarOn)
    {
      destroyWindowID (w->wxsb.sbslider);
      destroyWindowID (w->wxsb.sbarrowup);
      destroyWindowID (w->wxsb.sbarrowdown);
      destroyWindowID (w->wxsb.sbmain);
    }
  destroyWindowID (w->wxwin);
}

int
xiStdX ()
{
  return stdX;
}

int
xiStdY ()
{
  return stdY;
}

int
xiStdWidth ()
{
  return stdWidth;
}

int
xiStdHeight ()
{
  return stdHeight;
}

int
xiSTX ()
{
  return stX;
}

int
xiSTY ()
{
  return stY;
}

local void
xiClearTextCursor (wnd * w)
{
  int x0 = w->wxcx, y0 = w->wxcy;

  if (xiLocked)
    return;
  if (!(w->wxstat & WDX_CACTIVE))
    return;
  if (!(w->wxstat & WDX_CON))
    return;
  XCopyPlane (dpy, w->wxmain, w->wxmain, tccgc, XPX (x0), XPY (y0),
	      wInc, hInc, XPX (x0), XPY (y0), cplane);
  w->wxstat &= ~WDX_CON;
#if 0
  XSync (dpy, False);
#endif
}

local void
xiDrawTextCursor (wnd * w, small x, small y)
{
  if (xiLocked)
    return;
  if (!(w->wxstat & WDX_CACTIVE))
    return;
  if (w->wxstat & WDX_CON)
    return;
  XCopyPlane (dpy, w->wxmain, w->wxmain, tcsgc, XPX (x), XPY (y),
	      wInc, hInc, XPX (x), XPY (y), splane);
  w->wxstat |= WDX_CON;
#if 0
  XSync (dpy, False);
#endif
}

void
xiPos (wnd * w, small x, large y)
{
  if (!((w->wxstat & WDX_CON) && w->wxcx == x && w->wxcy == y))
    {
      xiClearTextCursor (w);
      xiDrawTextCursor (w, x, y);
    }
  w->wxcx = x;
  w->wxcy = y;
}

void
xiLock ()
{
  if (!xiLocked)
    xiFlush ();
  xiLocked = TRUE;
}

void
xiUnLock (bool q)
{
  register wnd *w = Twnd;
  xiLocked = FALSE;
  wredraw (w);
  xiPos (w, w->wxcx, w->wxcy);
  xiFlush ();
}

void
xiClear (wnd * w)
{
  if (xiLocked)
    return;
  xiClearTextCursor (w);
  XClearWindow (dpy, w->wxmain);
#if 0
  XSync (dpy, False);
#endif
}

void
xiRedraw (wnd * w, small x0, small x1, small y0, small y1)
{
  XEvent e;
  e.xexpose.type = Expose;
  e.xexpose.display = dpy;
  e.xexpose.window = w->wxmain;
  e.xexpose.x = XPX (x0);
  e.xexpose.y = XPY (y0);
  e.xexpose.width = XPX (x1 - x0);
  e.xexpose.height = XPY (y1 - y0);
  e.xexpose.count = 0;
  XSendEvent (dpy, w->wxmain, False, 0, &e);
}

void
xiBlkOn (wnd * w, box b)
{
  XGCValues rGCValues;
  XGetGCValues (dpy, w->wxgc, GCForeground | GCBackground, &rGCValues);
  XSetForeground (dpy, w->wxgc, rGCValues.background);
  XSetBackground (dpy, w->wxgc, rGCValues.foreground);
  /*   XOR    */
  XSetFunction (dpy, w->wxgc, GXxor);

  /* printf("Old block: (%d, %d)-(%d, %d)\n",w->block.x0, w->block.y0, w->block.x1, w->block.y1);
     printf("New block: (%d, %d)-(%d, %d)\n",b.x0, b.y0, b.x1, b.y1); */

  if (!w->block_active)
    {
      /*     =>   . */
      /*     */
      w->block_active = 1;
      /*    */
      w->block = b;
      /*   */

      XFillRectangle (dpy, w->wxmain, w->wxgc,
		      XPX (w->block.x0), XPY (w->block.y0),
		      XPX (w->block.x1 - w->block.x0),
		      XPY (w->block.y1 - w->block.y0));
      /* printf ("Block: (%d, %d), (%d, %d)\n", b.x0, b.y0, b.x1, b.y1); */
    }
  else
    {
      /*    =>   . */
      /* printf ("Block: (%d, %d), (%d, %d)\n", b.x0, b.y0, b.x1, b.y1); */
      /*         ,
         ..      */
      if (b.x0 == w->block.x0 && b.y0 == w->block.y0)
	{
	  /*    y */
	  if (b.y1 > w->block.y1)
	    {
	      /*
	         (x0,y0)
	                   >
	         block(x1,y1)        X
	                 
	                        Y
	                 V
	       */
	      /*    : (       b.x0, w->block.y1)
	            : (       b.x1,        b.y1) */
	      if (Ty > w->wty + w->block.y0)	/*  ,   */
		XFillRectangle (dpy, w->wxmain, w->wxgc,
				XPX (b.x0), XPY (w->block.y1),
				XPX (b.x1 - b.x0), XPY (b.y1 - w->block.y1));
	      else		/*   +  */
		XFillRectangle (dpy, w->wxmain, w->wxgc,
				XPX (b.x0), XPY (w->block.y0),
				XPX (b.x1 - b.x0), XPY (1));
	    }
	  else if (b.y1 < w->block.y1)
	    {
	      /*
	         (x0,y0)
	            b.y0   >
	         block               X
	          b.y1   
	         block          Y
	                 V
	         (x1,y1)
	       */
	      /*    : (       b.x0,        b.y1)
	            : (       b.x1, w->block.y1) */
	      if ((b.y1 > w->wsh - ROLL_LINE) && (b.y0 == w->wsh - ROLL_LINE))
		{
		  /*    ,     -   */
		  XFillRectangle (dpy, w->wxmain, w->wxgc,
				  XPX (b.x0), XPY (b.y0 - 1),
				  XPX (b.x1 - b.x0), XPY (1));
		}
	      else
		{
		  /*        */
		  XFillRectangle (dpy, w->wxmain, w->wxgc,
				  XPX (b.x0), XPY (b.y1),
				  XPX (b.x1 - b.x0),
				  XPY (w->block.y1 - b.y1));
		}
	    }
	  else if (b.x0 == w->block.x0 && b.x1 == w->block.x1)
	    {
	      /*   y . -     */
	      if ((w->block.y1 == w->wsh)
		  && (Ty + 1 > (w->wty + w->block.y0)))
		{
		  if (!Ty || Ty == w->wtext->flines)
		    goto end;
		  if (b.y0 != w->wsh - ROLL_LINE)
		    {
		      /*   +      */
		      XFillRectangle (dpy, w->wxmain, w->wxgc,
				      XPX (b.x0), XPY (b.y0),
				      XPX (b.x1 - b.x0), XPY (1));
		    }
		  else
		    {
		      /*   +       */
		      XFillRectangle (dpy, w->wxmain, w->wxgc,
				      XPX (b.x0), XPY (b.y0 - 1),
				      XPX (b.x1 - b.x0), XPY (1));
		      XFillRectangle (dpy, w->wxmain, w->wxgc,
				      XPX (b.x0), XPY (w->wsh - 1),
				      XPX (b.x1 - b.x0), XPY (1));
		    }

		}
	      else if (!(w->block.y0) && (Ty < (w->wty + w->block.y1)))
		{
		  if (!Ty || Ty == w->wtext->flines)
		    goto end;
		  else if (b.y1 != ROLL_LINE)
		    {
		      /*   +      */
		      XFillRectangle (dpy, w->wxmain, w->wxgc,
				      XPX (b.x0), XPY (b.y1 - 1),
				      XPX (b.x1 - b.x0), XPY (1));
		    }
		  else
		    {
		      /*   +       */
		      XFillRectangle (dpy, w->wxmain, w->wxgc,
				      XPX (b.x0), XPY (b.y1),
				      XPX (b.x1 - b.x0), XPY (1));
		      XFillRectangle (dpy, w->wxmain, w->wxgc,
				      XPX (b.x0), XPY (0),
				      XPX (b.x1 - b.x0), XPY (1));
		    }
		}
	    }
	  /*   y   */
	  /*    x */
	  if (b.x1 > w->block.x1)
	    {
	      /*
	         (x0,y0)        b.x1
	                 >
	         block              X
	                 
	         (x1,y1)       Y
	         V
	       */
	      /*    : (w->block.x1,        b.y0)
	            : (       b.x1,        b.y1) */
	      XFillRectangle (dpy, w->wxmain, w->wxgc,
			      XPX (w->block.x1), XPY (b.y0),
			      XPX (b.x1 - w->block.x1), XPY (b.y1 - b.y0));
	    }
	  else if (b.x1 < w->block.x1)
	    {
	      /*
	         (x0,y0)   b.x1
	                 >
	         block              X
	                 
	         (x1,y1)  Y
	         V
	       */
	      /*    : (       b.x1,        b.y0)
	            : (w->block.x1,        b.y1) */
	      XFillRectangle (dpy, w->wxmain, w->wxgc,
			      XPX (b.x1), XPY (b.y0),
			      XPX (w->block.x1 - b.x1), XPY (b.y1 - b.y0));
	    }
	  else
	    {
	      /*  :   */
	    }
	}
      else if (b.x1 == w->block.x1 && b.y1 == w->block.y1)
	{
	  /*    y */
	  if (b.y0 < w->block.y0)
	    {
	      /*
	         (b.x0,b.y0)
	                   >
	                              X
	                   
	         (x0,y0)block           Y
	                   V
	         (x1,y1)
	       */
	      /*    : (       b.x0,        b.y0)
	            : (       b.x1, w->block.y0) */

	      if (Ty < w->wty + w->block.y1 - 1)	
		{
		  /*    */
		  XFillRectangle (dpy, w->wxmain, w->wxgc,
				  XPX (b.x0), XPY (b.y0),
				  XPX (b.x1 - b.x0),
				  XPY (w->block.y0 - b.y0));
		}
	      else		
		{
		  /*   +  */
		  XFillRectangle (dpy, w->wxmain, w->wxgc,
				  XPX (b.x0), XPY (w->block.y1 - 1),
				  XPX (b.x1 - b.x0), XPY (1));
		}
	    }
	  else if (b.y0 > w->block.y0)
	    {
	      /*
	         (x0,y0)
	          y0       >
	          block               X
	          b.y0     
	         (b.x0,b.y0)block           Y
	                   V
	         (x1,y1)
	       */
	      /*    : (       b.x0, w->block.y0)
	            : (       b.x1,        b.y0) */
	      if ((b.y0 < ROLL_LINE) && (b.y1 == ROLL_LINE))
		{
		  /*    ,     -   */
		  XFillRectangle (dpy, w->wxmain, w->wxgc,
				  XPX (b.x0), XPY (b.y1),
				  XPX (b.x1 - b.x0), XPY (1));
		}
	      else
		{
		  /*        */
		  XFillRectangle (dpy, w->wxmain, w->wxgc,
				  XPX (b.x0), XPY (b.y0 - 1),
				  XPX (b.x1 - b.x0),
				  XPY (b.y0 - w->block.y0));
		}
	    }
	  else
	    {
	      /*   y :   */
	    }

	  /*   y   */
	  /*    x */
	  if (b.x0 < w->block.x0)
	    {
	      /*
	         b.x0  (x0,y0)
	                   >
	          block               X
	                   
	         (x1,y1)       Y
	         V
	       */
	      /*    : (       b.x0,        b.y0)
	            : (w->block.x0,        b.y1) */
	      XFillRectangle (dpy, w->wxmain, w->wxgc,
			      XPX (b.x0), XPY (b.y0),
			      XPX (w->block.x0 - b.x0), XPY (b.y1 - b.y0));
	    }
	  else if (b.x0 > w->block.x0)
	    {
	      /*
	         (x0,y0)  b.x0
	                 >
	          block             X
	                 
	         (x1,y1)  Y
	         V
	       */
	      /*    : (w->block.x0,        b.y0)
	            : (       b.x0,        b.y1) */
	      XFillRectangle (dpy, w->wxmain, w->wxgc,
			      XPX (w->block.x0), XPY (b.y0),
			      XPX (b.x0 - w->block.x0), XPY (b.y1 - b.y0));
	    }
	  else
	    {
	      /*  :   */
	    }
	}
      else
	{
	  /*  :     */
	  printf ("Internal error during block operation\n");
	  goto end;
	}
      /*       */
      /*    */
      w->block = b;
    }
end:
  XSetForeground (dpy, w->wxgc, rGCValues.foreground);
  XSetBackground (dpy, w->wxgc, rGCValues.background);
  /*       */
  XSetFunction (dpy, w->wxgc, GXcopy);

  xiDrawTextCursor (w, w->wxcx, w->wxcy);
}

void
xiBlkOff (wnd * w)
{
  if (w->block_active)
    {
      XGCValues rGCValues;

      XGetGCValues (dpy, w->wxgc, GCForeground | GCBackground, &rGCValues);
      XSetForeground (dpy, w->wxgc, rGCValues.background);
      XSetBackground (dpy, w->wxgc, rGCValues.foreground);
      /*   XOR    */
      XSetFunction (dpy, w->wxgc, GXxor);
      /*      */
      w->block_active = 0;
      /*   */
      XFillRectangle (dpy, w->wxmain, w->wxgc,
		      XPX (w->block.x0), XPY (w->block.y0),
		      XPX (w->block.x1 - w->block.x0),
		      XPY (w->block.y1 - w->block.y0));
      XSetForeground (dpy, w->wxgc, rGCValues.foreground);
      XSetBackground (dpy, w->wxgc, rGCValues.background);
      /*       */
      XSetFunction (dpy, w->wxgc, GXcopy);
    }
}

/*      (x0, y0), (x1, y1) */
local void
xiBlkRedraw (wnd * w, small x0, small x1, small y0, small y1)
{
  if (w->block_active)
    {
      box b;
      XGCValues rGCValues;

      /*     */
      if (w->block.x0 > x1 || w->block.x1 < x0
	  || w->block.y0 > y1 || w->block.y1 < y0)
	return;

      b.x0 = (w->block.x0 > x0 ? w->block.x0 : x0);
      b.y0 = (w->block.y0 > y0 ? w->block.y0 : y0);
      b.x1 = (w->block.x1 < x1 ? w->block.x1 : x1);
      b.y1 = (w->block.y1 < y1 ? w->block.y1 : y1);

#if 0
      printf ("Block:  (%d, %d), (%d, %d)\n", w->block.x0, w->block.y0,
	      w->block.x1, w->block.y1);
      printf ("Area:   (%d, %d), (%d, %d)\n", x0, y0, x1, y1);
      printf ("Redraw: (%d, %d), (%d, %d)\n", b.x0, b.y0, b.x1, b.y1);
#endif

      XGetGCValues (dpy, w->wxgc, GCForeground | GCBackground, &rGCValues);
      XSetForeground (dpy, w->wxgc, rGCValues.background);
      XSetBackground (dpy, w->wxgc, rGCValues.foreground);
      /*   XOR    */
      XSetFunction (dpy, w->wxgc, GXxor);
      /*   */
      XFillRectangle (dpy, w->wxmain, w->wxgc,
		      XPX (b.x0), XPY (b.y0),
		      XPX (b.x1 - b.x0), XPY (b.y1 - b.y0));
      XSetForeground (dpy, w->wxgc, rGCValues.foreground);
      XSetBackground (dpy, w->wxgc, rGCValues.background);
      /*       */
      XSetFunction (dpy, w->wxgc, GXcopy);
    }
}

/*       w */
void
xiOnDetachWnd (wnd * w)
{
  w->block_active = 0;
  /* printf ("xiOnDetachWnd\n"); */
}

local char
xitc2fc (tchar tc)
{
  return tv_ASCII[tc & 0377];
}

local char str[MAXLPAC];
void
xiText (wnd * w, int x, int y, tchar * tp, int l)
{
  register char *p;
  register int i = l;
  int wid;
  if (xiLocked)
    return;
  xiClearTextCursor (w);
  for (p = str; i--; *p++ = xitc2fc (*tp++));
  *p = 0;
  XDrawImageString (dpy, w->wxmain, w->wxgc, XPX (x), XPY (y) + ascent, str,
		    l);
#if 0
  XSync (dpy, False);
#endif
}

void
xiSpaces (wnd * w, int x, int y, int l)
{

  if (xiLocked)
    return;
  if (l <= 0)
    return;
  xiClearTextCursor (w);
  XClearArea (dpy, w->wxmain, XPX (x), XPY (y), l * wInc, hInc, False);
#if 0
  XSync (dpy, False);
#endif
}

void
xiTxblt (wnd * w, int x0, int y0, int x1, int y1, int dx, int dy)
{
  if (xiLocked)
    return;
  xiClearTextCursor (w);
  XCopyArea (dpy, w->wxmain, w->wxmain, w->wxgc, XPX (x0), XPY (y0),
	     XPX (x1 - x0), XPY (y1 - y0), XPX (x0 + dx), XPY (y0 + dy));
}

void
xiWaitEvent ()
{
  XEvent event;
  if (checkKeyBuf ())
    return;
  if (scrollDir)
    {
      handleScroll (scrollDir);
      return;
    }
  do
    XNextEvent (dpy, &event);
  while (!xiHandleEvent (&event));

  return;
}

local Bool
anyEvent (Display * dpy, XEvent * e, XPointer arg)
{
  return True;
}

bool xiCheckEvent ()
{
  XEvent event;
  int i;
  if (checkKeyBuf ())
    return TRUE;
  while (XCheckIfEvent (dpy, &event, anyEvent, 0))
    if (xiHandleEvent (&event))
      return TRUE;
#if 0
  if (scrollDir)
    {
      handleScroll (scrollDir);
      return TRUE;
    }
#endif
  return FALSE;
}

void
scbell ()
{
  XBell (dpy, 25);
}

local bool handleMainEvent (wnd * w, XEvent * e);
local bool handleWindowEvent (wnd * w, XEvent * e);
local bool handleScrollBarEvent (wnd * w, XEvent * e);
local bool handleCommonEvent (wnd * w, XEvent * e);
local bool handleKeyPress (XEvent * e);
#ifdef STATUS_IN_MAIN_WINDOW
local bool handleStatusBarEvent (wnd * w, XEvent * e);
#endif /* STATUS_IN_MAIN_WINDOW */

local bool
xiHandleEvent (XEvent * e)
{
  wnd *w;
  large *pw, wti;
  Atom ta;
  int tf;
  unsigned long tn, tb;

  if (e->xany.type == DestroyNotify)
    return FALSE;
#ifdef XIDEBUGEVENT
  printf ("event: %o %s \n", e->xany.window, xiEventNames[e->xany.type]);
#endif
  XGetWindowProperty (dpy, e->xany.window, winID, 0, 1, False,
		      winTyp, &ta, &tf, &tn, &tb, (unsigned char **) &pw);
  w = wdWindow (*pw);
  XFree (pw);
  XGetWindowProperty (dpy, e->xany.window, winTID, 0, 1, False,
		      winTyp, &ta, &tf, &tn, &tb, (unsigned char **) &pw);
  wti = *pw;
  XFree (pw);
  switch (wti)
    {
    case WTI_WINDOW:
      return handleWindowEvent (w, e);
    case WTI_MAIN:
      return handleMainEvent (w, e);
    case WTI_SCROLLBAR:
      return handleScrollBarEvent (w, e);
#ifdef STATUS_IN_MAIN_WINDOW
    case WTI_STATUSBAR:
      return handleStatusBarEvent (w, e);
#endif /* STATUS_IN_MAIN_WINDOW */
    }
  return FALSE;
}

local bool
handleMainEvent (wnd * w, XEvent * e)
{
  int nHasMotionBuffer;

  switch (e->xany.type)
    {
#ifdef MARK_BLOCK_BY_MOUSE
    case MotionNotify:		
      /*      . */
      nHasMotionBuffer = XDisplayMotionBufferSize (dpy);
      while (XCheckMaskEvent (dpy, Button1MotionMask, e));
      if (nHasMotionBuffer)
	{
	  XTimeCoord *prCoord;
	  int nEv = 0, i;
	  int tempX, tempY;
	  static Time nPrevTime, nTime;

	  nTime = e->xmotion.time;
	  prCoord =
	    XGetMotionEvents (dpy, e->xany.window, nPrevTime, nTime, &nEv);
	  nPrevTime = nTime;
	  for (i = 0; i < nEv; i++)
	    {
	      tempX = WPX (e->xbutton.x) + w->wtx;
	      tempY = WPY (e->xbutton.y) + w->wty;
	    }
	  if (!w->block_active)
	    {
	      xiKey = XI_KEY_START_BLOCK;
	      return TRUE;
	    }
	  if (tempX == xiTx && tempY == xiTy)
	    return FALSE;

	  if (ABS (tempX - xiTx) > ABS (tempY - xiTy))
	    {
	      xiTx = tempX;
	      tesetxy ();
	      Lx = Tx;
	    }
	  else
	    {
	      xiTy = tempY;
	      tesetxy ();
	    }
	  xiKey = XI_KEY_SETXY;
	  return TRUE;
	}
#endif

    case Expose:
    case GraphicsExpose:
/*       if( !(w->wtext) ) break; */
      if (w->wxstat & WDX_REDRAW)
	{
	  small x0 = WPX (e->xexpose.x);
	  small y0 = WPY (e->xexpose.y);
	  small x1 = x0 + WPX (e->xexpose.width) + 2;
	  small y1 = y0 + WPY (e->xexpose.height) + 2;
	  wrdrwcallback (w, x0, x1, y0, y1);
	  xiBlkRedraw (w, x0, x1, y0, y1);
	}
      if (!(e->xexpose.count))
	{
	  xiDrawTextCursor (w, w->wxcx, w->wxcy);
	  w->wxstat |= WDX_REDRAW;
	}
    case NoExpose:
      break;
    case ConfigureNotify:
      w->wsw = WPX (e->xconfigure.width);
      w->wsh = WPY (e->xconfigure.height);
      {
	small x = w->wtx + w->wxcx;
	large y = w->wty + w->wxcy;
	wadjust (w, x, y);
	wpos (w, x, y);
      }
      break;
    case FocusIn:
      {
	XEvent t;
	while (XCheckTypedWindowEvent (dpy, w->wxmain, ButtonPress, &t));
      }
      goto dflt;
#ifdef MARK_BLOCK_BY_MOUSE
    case ButtonRelease:
      if (w->block_active)
	{
	  xiKey = XI_KEY_START_BLOCK;
	  xiMarkSelection ();
	  return TRUE;
	}
      break;
#endif
    case ButtonPress:
      if (e->xbutton.button == Button2)
	{
	  //printf ("Button 2 pressed\n");
	  /* Convert selection to string and send SelectionNotify event to himself */
	  XConvertSelection (dpy, XA_PRIMARY, XA_STRING, XA_STRING, w->wxmain,
			     e->xbutton.time);
	}
      else if (e->xbutton.button == specButton)
	{
	  if (w == Twnd)
	    {
	      xiTx = WPX (e->xbutton.x) + w->wtx;
	      xiTy = WPY (e->xbutton.y) + w->wty;
	      xiKey = XI_KEY_SETXY;
	      return TRUE;
	    }
	}
#ifdef SCROLL_BY_MOUSE_WHEEL
#define XI_KEY_UP	(0x2ff & XK_Up)
#define XI_KEY_DOWN	(0x2ff & XK_Down)
      else if (e->xbutton.button == Button4)
	{
	  if (w == Twnd)
	    {
	      xiKey = XI_KEY_UP;
	      //printf ("Button4 pressed\n");
	      return TRUE;
	    }
	}
      else if (e->xbutton.button == Button5)
	{
	  if (w == Twnd)
	    {
	      xiKey = XI_KEY_DOWN;
	      //printf ("Button5 pressed\n");
	      return TRUE;
	    }
	}
#endif
      break;
    case SelectionNotify:
#if 0
      printf ("SelectionNotify event\n");

      printf ("type	 = %d\n", (int)e->xselection.type);
      printf ("serial	 = %ld\n", e->xselection.serial);
      printf ("send	 = %d\n", (int)e->xselection.send_event);
      printf ("display	 = %p\n", (int)e->xselection.display);
      printf ("requestor = %p\n", (int)e->xselection.requestor);
      printf ("selection = %d\n", (int)e->xselection.selection);
      printf ("target	 = %d\n", (int)e->xselection.target);
      printf ("property  = %d\n", (int)e->xselection.property);
      printf ("time	 = %d\n", (int)e->xselection.time);
#endif

      if (e->xselection.property != None)
	{
	  Atom type;
	  int format;
	  unsigned long after;
	  /* Get property as string */
	  if (XGetWindowProperty (dpy, w->wxmain, e->xselection.property, 0,
				  16535, True, XA_STRING, &type, &format,
				  &keyN, &after, &keyBuf) == Success)
	    {
	      //printf ("SelectionNotify event success: %s, %d\n", keyBuf, keyN);
	      keyPtr = keyBuf;
	      checkKeyBuf ();
	      return TRUE;
	    }
	  else
	    {
	      //printf ("SelectionNotify event fail\n");
	      keyN = 0;
	      keyBuf = NIL;
	    }
	}
      break;
    case SelectionRequest:
#if 0
      printf ("SelectionRequest event\n");
      printf ("selection = %d\n", e->xselectionrequest.selection);
      printf ("target = %d\n", e->xselectionrequest.target);
      printf ("property = %d\n", e->xselectionrequest.property);
      printf ("requestor = %p\n", e->xselectionrequest.requestor);
      printf ("owner = %p\n", e->xselectionrequest.owner);
      printf ("w->wxmain = %p\n", w->wxmain);
#endif

      {
      char * strSelection = xiGetSelectionString ();
      XEvent event_send;

      /* Assign string to property */
      XChangeProperty (dpy, e->xselectionrequest.requestor, e->xselectionrequest.property,
		       e->xselectionrequest.target, 8, PropModeAppend /*PropModeReplace*/,
		       strSelection, strlen (strSelection));

      /* Send SelectionNotify event to requestor */
      event_send.xselection.type       = SelectionNotify;
      event_send.xselection.serial     = e->xselectionrequest.serial;
      event_send.xselection.send_event = 1;
      event_send.xselection.display    = e->xselectionrequest.display;
      event_send.xselection.requestor  = e->xselectionrequest.requestor;
      event_send.xselection.selection  = e->xselectionrequest.selection;
      event_send.xselection.target     = e->xselectionrequest.target;
      event_send.xselection.property   = e->xselectionrequest.property;
      event_send.xselection.time       = e->xselectionrequest.time;

      XSendEvent (dpy, e->xselectionrequest.requestor, 0, 0, &event_send);

      }
      break;

    default:
    dflt:;
      return handleCommonEvent (w, e);
    }
  return FALSE;
}

local bool
handleWindowEvent (wnd * w, XEvent * e)
{
  switch (e->xany.type)
    {
    case ConfigureNotify:
      {
	small corr = 2 * pad;	/* why this does not work? - 2 * pad */

	w->wsx = e->xconfigure.x;
	w->wsy = e->xconfigure.y;
	if (w->wtyp == WND_NORMAL && scrollbarOn)
	  {
	    XMoveResizeWindow (dpy, w->wxmain, pad, pad,
			       ((e->xconfigure.width + corr - SCB_WIDTH -
				 SCB_PAD) / wInc) * wInc,
			       ((e->xconfigure.height + corr) / hInc) * hInc);
	    XMoveResizeWindow (dpy, w->wxsb.sbmain,
			       e->xconfigure.width - SCB_WIDTH + SCB_BORDER -
			       SCB_PAD, pad, SCB_WIDTH - 2 * SCB_BORDER,
			       e->xconfigure.height + corr - 2 * SCB_BORDER);
	  }
	else
#ifdef STATUS_IN_MAIN_WINDOW
	if (w->wtyp == WND_NORMAL)
	  {
	    XResizeWindow (dpy, w->wxmain,
			   ((e->xconfigure.width + corr) / wInc) * wInc,
			   ((e->xconfigure.
			     height + corr - STATUS_WINDOW_HEIGHT -
			     STATUS_WINDOW_PAD) / hInc) * hInc);
	    XResizeWindow (dpy, w->wxstatusbar,
			   ((e->xconfigure.width + 2 * pad) / wInc) * wInc,
			   STATUS_WINDOW_HEIGHT + STATUS_WINDOW_PAD);
	    setStatusWidth (WPX (e->xconfigure.width));
	  }
	else
	  XResizeWindow (dpy, w->wxmain,
			 ((e->xconfigure.width + corr) / wInc) * wInc,
			 ((e->xconfigure.
			   height + corr - STATUS_WINDOW_HEIGHT -
			   STATUS_WINDOW_PAD) / hInc) * hInc);
#else
	  XResizeWindow (dpy, w->wxmain,
			 ((e->xconfigure.width - 2 * pad) / wInc) * wInc,
			 ((e->xconfigure.height - 2 * pad) / hInc) * hInc);
#endif /* STATUS_IN_MAIN_WINDOW */
	break;
      }
    case UnmapNotify:
      /*    */
      w->wnd_shown = 0;
      /* printf ("User UnmapNotify\n"); */
      break;
    case MapNotify:
      /*    */
      w->wnd_shown = 1;
      /* printf ("User MapNotify\n"); */
      break;

    default:
      return handleCommonEvent (w, e);
    }
  return FALSE;
}

local bool
handleScrollBarEvent (wnd * w, XEvent * e)
{
  switch (e->xany.type)
    {
    case Expose:
      if (e->xexpose.window == w->wxsb.sbarrowup)
	XCopyArea (dpy, upaPixmap, e->xexpose.window, w->wxgc, 0, 0,
		   up_arrow_width, up_arrow_height, 0, 0);
      if (e->xexpose.window == w->wxsb.sbarrowdown)
	XCopyArea (dpy, downaPixmap, e->xexpose.window, w->wxgc, 0, 0,
		   down_arrow_width, down_arrow_height, 0, 0);
      if (e->xexpose.window == w->wxsb.sbslider)
	XCopyArea (dpy, sliderPixmap, e->xexpose.window, w->wxgc, 0, 0,
		   slider_width, slider_height, 0, 0);
      break;
    case ConfigureNotify:
      break;
    case ButtonPress:
      if (e->xbutton.button != Button1)
	break;
      if (w != Twnd)
	break;
      if (e->xexpose.window == w->wxsb.sbarrowup)
	{
	  scrollDir = -1;
	  handleScroll (scrollDir);
	  return TRUE;
	}
      if (e->xexpose.window == w->wxsb.sbarrowdown)
	{
	  scrollDir = 1;
	  handleScroll (scrollDir);
	  return TRUE;
	}
      if (e->xexpose.window == w->wxsb.sbslider)
	{
	}
      break;
    case ButtonRelease:
      scrollDir = 0;
      break;
    default:
      return handleCommonEvent (w, e);
    }
  return FALSE;
}

#ifdef STATUS_IN_MAIN_WINDOW
local bool
handleStatusBarEvent (wnd * w, XEvent * e)
{
  switch (e->xany.type)
    {
    case Expose:

      redrawWndStatusBar (w);
      break;
    default:
      return handleCommonEvent (w, e);
    }
  return FALSE;
}
#endif /* STATUS_IN_MAIN_WINDOW */

local bool
handleCommonEvent (wnd * w, XEvent * e)
{
  switch (e->xany.type)
    {
    case FocusIn:
      focus = TRUE;
      w->wxstat |= WDX_CACTIVE;
      xiTWnd = w;
      xiKey = XI_KEY_FOCUS;

      /*+++
         printf("SetFocus (FocusIn)\n");
         +++ */

      return TRUE;
      break;

    case FocusOut:
      focus = FALSE;
      xiClearTextCursor (w);
      w->wxstat &= ~WDX_CACTIVE;
      break;

    case EnterNotify:
      {
	Window f;
	int r;
	if (focus)
	  break;
	XGetInputFocus (dpy, &f, &r);
	if (f != PointerRoot && f != w->wxwin)
	  break;
	w->wxstat |= WDX_CACTIVE;
	xiTWnd = w;
	xiKey = XI_KEY_FOCUS;

	/*+++
	   printf("SetFocus (EnterNotify)\n");
	   +++ */

	return TRUE;
      }

    case LeaveNotify:
      if (focus)
	break;
      xiClearTextCursor (w);
      w->wxstat &= ~WDX_CACTIVE;
      break;

    case MappingNotify:
      if (e->xmapping.request == MappingKeyboard)
	XRefreshKeyboardMapping (&e->xmapping);
      break;

    case KeyPress:
      return handleKeyPress (e);

    case ButtonRelease:
      break;

    case ClientMessage:
      if (e->xclient.message_type == winProtocolsAtom
	  && (Atom) e->xclient.data.l[0] == winDeleteWindowAtom)
	{
	  // printf ("Got delete window atom\n");
	  tmSaveBackExit ();
	}
      break;

    default:
      break;
    }
  return FALSE;
}

local void
handleScroll (small dir)
{
  register wnd *w = Twnd;

  switch (dir)
  {
  case -1: /* arrow up */
    xiKey = XI_KEY_UP;
    break;

  case	0: /* nothing */
    break;

  case	1: /* arrow down */
    xiKey = XI_KEY_DOWN;
    break;

  default: /* slider */
    xiTx = w->wxcx + w->wtx;
    xiTy = w->wxcy + w->wty + dir;
    xiKey = XI_KEY_SETXY;
    break;
  }
  scrollDir = 0;
}

local bool
handleKeyPress (XEvent * e)
{
  KeySym k;
  int index = 0;
  unsigned int s;
#ifdef DXK_Remove
#define IsSpecialKey( keysym ) \
  ((((unsigned)(keysym) >= XK_BackSpace) && ((unsigned)(keysym) <= XK_R15)) \
            || (keysym) == DXK_Remove )
#else
#define IsSpecialKey( keysym ) \
  (((unsigned)(keysym) >= XK_BackSpace) && ((unsigned)(keysym) <= XK_R15))
#endif
  s = e->xkey.state;
  if (s & LockMask)
    index = 1;
  if (s & ShiftMask)
    index = 1 - index;
rep:
  k = XLookupKeysym (&(e->xkey), index);
  // printf ("Key = 0%o\n", k);
  if (k == NoSymbol)
    if (index)
      {
	index = 0;
	goto rep;
      }
    else
      {
#ifdef XIDEBUGKEY
	printf ("NoSymbol \n");
#endif
	return FALSE;
      }
  if (IsModifierKey (k))
    {
      /* Allow Alt gr be usual key */
      if (k == 0177752)
        {
          xiKey = 01040; /* WIN_2 */
          return TRUE;
        }
      return FALSE;
    }
  s |= LockMask;
  if (IsSpecialKey (k))
    {
      k &= (s << 8) | 0377;
#ifdef XIDEBUGKEY
      printf ("Special ");
#endif
    }
  else
    {
      if (s & ControlMask)
	{
	  k &= ~040;
	  k -= 0100;
	}
      k &= 0377;
    }

  /* VVB: remove the NumLock bit (othewise too many equal commands) */
  k &= ~(010000);


#ifdef XIDEBUGKEY
  printf ("Key 0%o Index %d Mask 0%o XKey 0%o \n", k, index, s,
	  e->xkey.keycode);
  return FALSE;
#else

  /*+++
     printf( "Key %o Index %d Mask %o XKey %o \n", k, index, s, e->xkey.keycode );
     +++ */
  /* printf( "Key 0%o Index %d Mask 0%o XKey 0%o \n", k, index, s, e->xkey.keycode ); */

  /*
   * Cannot undersand behaviour of XFree-4.3 in Mandrake 9.1.
   * Codes Shift+F1 ... Shift+F12 translated to 1...12
   * The same promlem for Ctrl+Shift.
   * The same promlem for Shift+STAR.
   * Currently fix this here.
   */
  if (k >= 1 && k <= 12 && index == 1 && s == 3)
    k += 01675;
  if (k >= 0301 && k <= 0312 && index == 1 && s == 7)
    k += 03375;
  /* Shift+STAR */
  if (k == 041 && index == 1 && s == 3 && e->xkey.keycode == 077)
    k = 01652;

  xiKey = k;
  /* Process special keys */
  if (k == 0377 && s == 3 && e->xkey.keycode == 0153)
    {
      xiKey = XI_KEY_SHIFT_DELETE;	/* Shift+Delete */
      return TRUE;
    }
  if (k == 040 && s == 3 && e->xkey.keycode == 027)
    {
      xiKey = XI_KEY_SHIFT_TAB;	/* Shift+Tab */
      return TRUE;
    }
  if (k == 0300)
    {
      if (s == 7 && e->xkey.keycode == 027)
	{
	  xiKey = XI_KEY_CTRL_SHIFT_TAB;	/* Ctrl+Shift+Tab */
	  return TRUE;
	}
      if (s == 7 && e->xkey.keycode == 0101)
	{
	  xiKey = XI_KEY_CTRL_SHIFT_SPACE;	/* Ctrl+Shift+' ' */
	  return TRUE;
	}
      if (s == 6 && e->xkey.keycode == 0101)
	{
	  xiKey = XI_KEY_CTRL_SPACE;	/* Ctrl+' ' */
	  return TRUE;
	}
    }
  if (k == 0 && s == 7 && e->xkey.keycode == 013)
    {
      xiKey = XI_KEY_CTRL_SHIFT_2;	/* Ctrl+Shift+2 */
      return TRUE;
    }
  if (k == 036 && s == 7 && e->xkey.keycode == 017)
    {
      xiKey = XI_KEY_CTRL_SHIFT_6;	/* Ctrl+Shift+6 */
      return TRUE;
    }
  if (k == 0317 && s == 6 && e->xkey.keycode == 075)
    {
      xiKey = XI_KEY_CTRL_QUESTION;	/* Ctrl+? */
      return TRUE;
    }

  /* VVB: On terminals that send 0377 on BackSpace, convert it */
  /* to Ctrl+h                                                 */
  if (k == 0377 && s == 2 &&
      (e->xkey.keycode == 026 || e->xkey.keycode == 0274))
    {
      /* this is BackSpace without shift or control */
      xiKey = 010;		/* Ctrl+H */
      return TRUE;
    }

  /* VVB: Convert "Remove" on DEC terminals (that send 0) to TE_DC */
  /* and Shift+Remove to TE_DL                                     */
  if (k == 0 && e->xkey.keycode == 0214)	/* "Remove" key */
    {
      /* This is "Remove" key */
      if (s == 2)
	{
	  xiKey = 0377;
	  return TRUE;
	}
      else if (s == 3)
	{
	  xiKey = XI_KEY_SHIFT_DELETE;	/* Delete line */
	  return TRUE;
	}
    }

  /*   Alt+ */
  if (k >= 0 && k < 0200 && (s == 012 || s == 013))
    {
      xiKey = k | XI_ALT_MASK;
      return TRUE;
    }

  /*??? What is it?
     if( xiKey == 017 ) quit_handler();
     else return TRUE;
     ??? */

  return TRUE;

#endif
}

void
xiFlush ()
{
  XSync (dpy, False);
}

local bool
checkKeyBuf ()
{
  if (keyN > 0)
    {
      xiKey = *keyPtr++;
      if (xiKey == '\n')
	xiKey = TE_CR;
      else if (xiKey == '\t')
	xiKey = LE_TAB;
      if (--keyN <= 0)
	{
	  XFree (keyBuf);
	  keyBuf = keyPtr = NIL;
	  keyN = 0;
	}
      return TRUE;
    }
  return FALSE;
}

/*        */
void xiMarkSelection ()
{
  XSetSelectionOwner (dpy, XA_PRIMARY, xiTWnd->wxmain, CurrentTime);
}

/*   -   */
char * xiGetSelectionString ()
{
  static char buf[MAXLPAC];

  LeGetSaveBuffer (buf, MAXLPAC);
  return buf;
}

/*    
   :  
   :   */
wnd *
xiNextWindow (wnd *w_curr)
{
  wnd *w_next;		/*   */

  w_next = WdGetNext (w_curr);
  if (!w_next)
    return 0;		/*    */
  XMapRaised (dpy, w_next->wxwin);
  XMapRaised (dpy, w_next->wxmain);
#ifdef STATUS_IN_MAIN_WINDOW
  XMapRaised (dpy, w_next->wxstatusbar);
#endif /* STATUS_IN_MAIN_WINDOW */
  XSetInputFocus (dpy, w_next->wxmain, RevertToParent, CurrentTime);
  return w_next;
}

/*    
   :  
   :   */
wnd *
xiPrevWindow (wnd *w_curr)
{
  wnd *w_prev;		/*   */

  w_prev = WdGetPrev (w_curr);
  if (!w_prev)
    return 0;		/*    */
  XMapRaised (dpy, w_prev->wxwin);
  XMapRaised (dpy, w_prev->wxmain);
#ifdef STATUS_IN_MAIN_WINDOW
  XMapRaised (dpy, w_prev->wxstatusbar);
#endif /* STATUS_IN_MAIN_WINDOW */
  XSetInputFocus (dpy, w_prev->wxmain, RevertToParent, CurrentTime);
  return w_prev;
}
